
#we can't load it anymore in sub gui contact_frame
$ldap_library_missing=false
begin
	require 'ldap'
rescue LoadError
	$log.error("You have to install ldap ruby library to be able to fill contact automatically")
	$ldap_library_missing=true
end

require "#{GNMSLIB}"+'/gui/config_window'
begin
	require 'yaml'
rescue LoadError
	$log.fatal("You must install yaml module for ruby")
	exit()
end
require 'yaml/store'

class ConfigGlobal

DEFAULT_MAIL_SERVER = "localhost"
DEFAULT_MAIL_SERVER_PORT = "25"
DEFAULT_SOUND_FILE = "Just beep"

	attr_reader :window
	attr_reader :default_width, :default_height, :default_map, :show_label, :noshow_fqdn, :show_tooltips, :confirm_delete, :confirm_quit, :log_level
	attr_reader :read_community, :write_community, :snmp_version, :snmp_port, :snmp_timeout, :snmp_retry, :mail_server_addr, :mail_server_port, :sms_device, :im_login, :im_password, :irc_server, :irc_port, :irc_channel
	attr_accessor :level
	attr_reader :active_find_node_state, :active_find_node_delay, :passive_find_node_state, :passive_find_node_delay, :mac_state, :mac_delay, :mac_lock, :mac_manufacturer, :syslog_mon, :syslog_port, :snmptrap_mon, :snmptrap_port, :snmptrap_community
	attr_reader :node_resolving, :node_resolving_delay
	attr_reader :port_mon, :port_mon_delay, :snmp_mon, :snmp_mon_delay, :wmi_mon, :wmi_mon_delay, :custom_mon, :custom_mon_delay, :jmx_mon, :jmx_mon_delay
	attr_reader :ping_path, :nmap_path, :ssh_path, :telnet_path, :browser_path, :vncviewer_path, :rdesktop_path, :xterm_path, :nmblookup_path, :xprobe_path, :wmic_path
	attr_accessor :image_path, :bg_type
	attr_reader :rgb, :label_text, :label_bg
	attr_reader :auto_save_map, :auto_save_map_value, :mail_server, :im_daemon, :irc_daemon
	attr_accessor :pixmap_size
	attr_accessor :host_label_view, :host_icon_view, :network_label_view, :network_icon_view, :map_display_view
   	attr_accessor :nmap_vers
	attr_accessor :mail_by_level, :sound_file_path_by_level, :script_name_by_level, :sms_num_by_level, :im_dest_by_level

#
#	save configuration to file as INF format, refresh general value
#	warning: deprecated
#
def save_config()

   fic_tmp=Tempfile.new(File.basename(GLOBAL_CONF_FILE))
  
	line_idx=0
	File.readlines(GLOBAL_CONF_FILE).each{|line|
		if line_idx == 1
		  fic_tmp.puts("#{get_map_width()}")
		  fic_tmp.puts("#{get_map_height()}")
		  fic_tmp.puts("#{$map}")
		  fic_tmp.puts("#{$config.host_label_view}")
		  fic_tmp.puts("#{$config.host_icon_view}")
		  fic_tmp.puts("#{$config.network_label_view}")
		  fic_tmp.puts("#{$config.network_icon_view}")
		  fic_tmp.puts("#{$config.map_display_view}")
		end
		#we rewrite all exept GENERAL paragrapher
		if (line_idx == 0) || (line_idx > 8)
			fic_tmp.print line
		end
		line_idx+=1		
	}
	fic_tmp.close
	if File.stat(fic_tmp.path).size?
		#all seems good
  		FileUtils.move(fic_tmp.path, GLOBAL_CONF_FILE)
	end

end

def read_config_yaml()

  if FileTest.exist?(GLOBAL_CONF_FILE)
	  if !File.readable?(GLOBAL_CONF_FILE) or !File.writable?(GLOBAL_CONF_FILE)
	  	$log.fatal("Wrong permission on #{GLOBAL_CONF_FILE} need read-write access")
		exit()
          end
	  begin
		db = YAML::load_file(GLOBAL_CONF_FILE)
	  rescue Exception => msg
	  	$log.fatal("Error reading configuration file #{GLOBAL_CONF_FILE}")
		exit()
	  end
          begin
	  @default_width = db["general"]["default_width"]
	  @default_height =  db["general"]["default_height"]
	  @default_map = db["general"]["default_map"]
	  @host_label_view = db["general"]["host_label_view"]
	  @host_icon_view = db["general"]["host_icon_view"]
	  @network_label_view = db["general"]["network_label_view"]
	  @network_icon_view = db["general"]["network_icon_view"]
	  @map_display_view = db["general"]["map_display_view"]
	  @show_label = db["general"]["show_label"]
	  @noshow_fqdn = db["general"]["noshow_fqdn"]
	  @show_tooltips = db["general"]["show_tooltips"]
	  @confirm_delete = db["general"]["confirm_delete"]
	  @confirm_quit = db["general"]["confirm_quit"]
	  @auto_save_map = db["general"]["auto_save_map"]
	  @auto_save_map_value = db["general"]["auto_save_map_value"]
	  @log_level = db["general"]["log_level"]
	  @mail_server = db["general"]["mail_server"]
	  @mail_server_addr = db["general"]["mail_server_addr"]
	  @mail_server_port = db["general"]["mail_server_port"]	  
	  @sms_device = db["general"]["sms_device"]
	  @im_daemon = db["general"]["im_daemon"]
	  @im_login = db["general"]["im_login"]
	  @im_password = blowfish_decode(Base64.decode64(db["general"]["im_password"]))
          @irc_daemon = db["general"]["irc_daemon"]
          @irc_server = db["general"]["irc_server"]
          @irc_port   = db["general"]["irc_port"]
          @irc_channel = db["general"]["irc_channel"]

	  @read_community = db["snmp"]["read_community"]
	  @write_community = db["snmp"]["write_community"]
	  @snmp_version = db["snmp"]["snmp_version"]
	  @snmp_port = db["snmp"]["snmp_port"]
	  @snmp_timeout = db["snmp"]["snmp_timeout"]
	  @snmp_retry = db["snmp"]["snmp_retry"]

	  @level = db["notification"]["level"]
	  $level_alert_type = db["notification"]["level_alert_type"]
	  @mail_by_level = db["notification"]["mail"]
	  @sound_file_path_by_level = db["notification"]["sound_file_path"]
	  @script_name_by_level = db["notification"]["script_name"]
	  @sms_num_by_level = db["notification"]["sms_num"]
	  @im_dest_by_level = db["notification"]["im_dest"]
	  
	  @active_find_node_state = db["scan"]["active_find_node"]["state"]
	  @active_find_node_delay = db["scan"]["active_find_node"]["delay"]
	  @passive_find_node_state = db["scan"]["passive_find_node"]["state"]
	  @passive_find_node_delay = db["scan"]["passive_find_node"]["delay"]  
	  @mac_state = db["scan"]["mac"]["state"]
	  @mac_delay = db["scan"]["mac"]["delay"]
	  @mac_lock = db["scan"]["mac"]["lock"]
	  @mac_manufacturer = db["scan"]["mac"]["manufacturer"]
	  @node_resolving = db["scan"]["node_resolving"]["state"]
	  @node_resolving_delay = db["scan"]["node_resolving"]["delay"]
	  @port_mon = db["scan"]["port"]["state"]
	  @port_mon_delay = db["scan"]["port"]["delay"]
	  @snmp_mon = db["scan"]["snmp"]["state"]
	  @snmp_mon_delay = db["scan"]["snmp"]["delay"]
	  @wmi_mon = db["scan"]["wmi"]["state"]
	  @wmi_mon_delay = db["scan"]["wmi"]["delay"]
	  @custom_mon = db["scan"]["custom"]["state"]
	  @custom_mon_delay = db["scan"]["custom"]["delay"]
	  @jmx_mon = db["scan"]["jmx"]["state"]
	  @jmx_mon_delay = db["scan"]["jmx"]["delay"]
	  @syslog_mon = db["scan"]["syslog"]["state"]
	  @syslog_port = db["scan"]["syslog"]["port"]
	  @snmptrap_mon = db["scan"]["snmptrap"]["state"]
	  @snmptrap_port = db["scan"]["snmptrap"]["port"]
	  @snmptrap_community = db["scan"]["snmptrap"]["community"]

	  @ping_path = db["path"]["ping"]
	  @nmap_path = db["path"]["nmap"]
	  @ssh_path = db["path"]["ssh"]
	  @telnet_path = db["path"]["telnet"]
	  @browser_path = db["path"]["browser"]
	  @vncviewer_path = db["path"]["vncviewer"]
	  @rdesktop_path = db["path"]["rdesktop"]
	  @xterm_path = db["path"]["terminal"]
	  @nmblookup_path = db["path"]["nmblookup"]
	  @xprobe_path = db["path"]["xprobe"]
	  @wmic_path = db["path"]["wmic"]

	  @pixmap_size = db["colors"]["pixmap_size"]
	  @bg_type = db["colors"]["bg_type"]
	  @label_text = db["colors"]["label_text"]
 	  @label_bg = db["colors"]["label_bg"]	  
	  @rgb = db["colors"]["rgb"]
	  @image_path = db["colors"]["image_path"]
	  rescue
	          $log.error("Conf reset as issues found when loading configuration file at #{GLOBAL_CONF_FILE}")
	  	  init_config_var()
	  end
  else
	  init_config_var()
  end
end

#
#	save configuration to file as YAML format
#
def write_config_yaml()

fic_tmp=Tempfile.new(File.basename(GLOBAL_CONF_FILE))

general =  {
	'default_width' => @default_width.to_i,
	'default_height' => @default_height.to_i,
	'default_map' => @default_map,
	'host_label_view' => @host_label_view,
	'host_icon_view' => @host_icon_view,
	'network_label_view' => @network_label_view,
	'network_icon_view' => @network_icon_view,
	'map_display_view' => @map_display_view,
	'show_label' => @show_label,
	'noshow_fqdn' => @noshow_fqdn,
	'show_tooltips' => @show_tooltips,
	'confirm_delete' => @confirm_delete,
	'confirm_quit' => @confirm_quit,
	'auto_save_map' => @auto_save_map,
	'auto_save_map_value' => @auto_save_map_value.to_i,
	'log_level' => @log_level,
	'mail_server' => @mail_server,
	'mail_server_addr' => @mail_server_addr,
	'mail_server_port' => @mail_server_port,
	'sms_device' => @sms_device,
	'im_daemon' => @im_daemon,	
	'im_login' => @im_login,
	'im_password' => Base64.encode64(blowfish_encode(@im_password)),
        'irc_daemon' => @irc_daemon,
        'irc_server' => @irc_server,
        'irc_port' => @irc_port,
        'irc_channel' => @irc_channel
        }
snmp = {
	'read_community' => @read_community,
	'write_community' => @write_community,
	'snmp_version' => @snmp_version,
	'snmp_port' => @snmp_port.to_i,
	'snmp_timeout' => @snmp_timeout.to_i,
	'snmp_retry' => @snmp_retry.to_i
	}

notification = {
	'level' => @level,
	'level_alert_type' =>  $level_alert_type,
	'mail' => @mail_by_level,
	'sound_file_path' => @sound_file_path_by_level,
	'script_name' => @script_name_by_level,
	'sms_num' => @sms_num_by_level,	
	'im_dest' => @im_dest_by_level
	}

scan = {
	'active_find_node' => {
				'state' => @active_find_node_state,
				'delay' => @active_find_node_delay.to_i,
				},
	'passive_find_node' => {
				'state' => @passive_find_node_state,
				'delay' => @passive_find_node_delay.to_i,
				},				
	'mac' => {
			'state' => @mac_state,
			'delay' => @mac_delay.to_i,
			'lock' => @mac_lock,
			'manufacturer' => {
					'state' => @mac_manufacturer
					}
				},
	'node_resolving' => {
				'state' => @node_resolving,
				'delay' => @node_resolving_delay.to_i
				},
	'port' => {
				'state' => @port_mon,
				'delay' => @port_mon_delay.to_i
						},
	'snmp' => {
				'state' => @snmp_mon,
				'delay' => @snmp_mon_delay.to_i
					},
	'wmi' => {
				'state' => @wmi_mon,
				'delay' => @wmi_mon_delay.to_i
					},

	'custom' => {
				'state' => @custom_mon,
				'delay' => @custom_mon_delay.to_i
					},
	'jmx' => {
				'state' => @jmx_mon,
				'delay' => @jmx_mon_delay.to_i
					},

	'syslog' => {
				'state' => @syslog_mon,
				'port' => @syslog_port.to_i
					},
	'snmptrap' => {
					'state' => @snmptrap_mon,
					'port' => @snmptrap_port.to_i,
					'community' => @snmptrap_community
						}
		}

path = {
	'ping' => @ping_path,
	'nmap' => @nmap_path,
	'ssh' => @ssh_path,
	'telnet' => @telnet_path,
	'browser' => @browser_path,
	'vncviewer' => @vncviewer_path,
	'rdesktop' => @rdesktop_path,
	'terminal' => @xterm_path,
	'nmblookup' => @nmblookup_path,
	'xprobe' => @xprobe_path,
	'wmic' => @wmic_path
		}

#keys = {}

colors = {
	'pixmap_size' => @pixmap_size,
	'bg_type' => @bg_type,
	'label_text' => @label_text,
        'label_bg' => @label_bg,
	'rgb' => @rgb,
	'image_path' => @image_path
		}

YAML::dump(general)
YAML::dump(snmp)
YAML::dump(notification)
YAML::dump(scan)
YAML::dump(path)
#YAML::dump(keys)
YAML::dump(colors)

db = YAML::Store.new(fic_tmp.path)
db.transaction{
  db['general'] = general 
  db['snmp'] = snmp 
  db['notification'] = notification 
  db['scan'] = scan 
  db['path'] = path
#  db['keys'] = keys
  db['colors'] = colors
}
	if File.stat(fic_tmp.path).size?
  		FileUtils.move(fic_tmp.path, GLOBAL_CONF_FILE)
	end
end

def init_config_var()
		@host_label_view="dns_name"
		@host_icon_view="type"
		@network_label_view="ip"
		@network_icon_view="type"
		@map_display_view="User defined"
 	   #map is set in mail
		@show_label=true
		@noshow_fqdn=false
		@show_tooltips=false
		@confirm_delete=true
		@confirm_quit=true
		@auto_save_map=false
		@auto_save_map_value=60
		@log_level="Info"
		@pixmap_size=35
		@bg_type="color"
                #black
		@label_text = [0, 0, 0]
		#grey
		@label_bg = [48251, 45824, 45824]
		@rgb=[48251, 45824, 45824]
		@mail_server=false
		@im_daemon=false
		@irc_daemon=false
end

def show()
  @window.show()
end

def visible()
  @window.visible()
end

def init_hash_conf_by_level(h)
	for l in $LEVEL
	  h[l]= nil
	end
end

def initialize ()
        @label_text = [0, 0, 0]
        grey = [48251, 45824, 45824]
	@label_bg = grey
	@rgb = grey
	@image_path = "#{PIXMAP_PATH}/bg"
	@bg_type = "color"
	#set this for the first time we launch gnms
	@port_mon = true
	@port_mon_delay = "60"
	@snmp_mon_delay = "60"
	@wmi_mon_delay = "60"
	@custom_mon_delay = "60"
	@jmx_mon_delay = "60"
	@active_find_node_delay = "300"
	@passive_find_node_delay = "300"	
	@node_resolving = true
	@node_resolving_delay = "120"
	@mac_delay = "60"
	@syslog_port="514"
	@snmptrap_port="162"
	@snmptrap_comunity="public"
	@mail_server_addr="localhost"
	@mail_server_port=25
	
	#store mail recipient for each severity level
	@mail_by_level = Hash.new
	init_hash_conf_by_level(@mail_by_level)
	#store sound path if one for each severity level
	@sound_file_path_by_level = Hash.new
	init_hash_conf_by_level(@sound_file_path_by_level)
	@sms_num_by_level = Hash.new
	init_hash_conf_by_level(@sms_num_by_level)
	@im_dest_by_level = Hash.new
	init_hash_conf_by_level(@im_dest_by_level)
	@script_name_by_level = Hash.new
	init_hash_conf_by_level(@script_name_by_level)
	
	begin
 		@window=ConfigWindow.new(self)
   rescue Exception => msg
      raise msg
   end

end


end
