class Contact
   attr_accessor :firstname, :lastname, :email, :phone, :mobile, :im, :pager, :title, :organization, :location, :note, :nb_use

#
#	add a contact
#
def Contact::add_contact(firstname, lastname, email, phone, mobile, im, pager, title, organization, location, note)
	if $contact["#{firstname}|#{lastname}"] == nil
		$contact["#{firstname}|#{lastname}"] = Contact.new(firstname, lastname, email, phone, mobile, im, pager, title, organization, location, note)
		return true
	end
	return false
end


#
#	delete a contact
#	return true is entry delete otherwise false
#
def Contact::del_contact(firstname, lastname)
	if !Contact::used?(firstname,lastname)
		$contact.delete("#{firstname}|#{lastname}")
		return true
	end
	return false
end

#
#	return contact's title
#
def Contact::get_contact_title(firstname, lastname)
	if Contact::contact_exist?(firstname, lastname)
		return $contact["#{firstname}|#{lastname}"].title
	end
end

#
#	return contact's organization
#
def Contact::get_contact_organization(firstname, lastname)
	if Contact::contact_exist?(firstname, lastname)
		return $contact["#{firstname}|#{lastname}"].organization
	end
end

#
#	return contact's email
#
def Contact::get_contact_email(firstname, lastname)
	if Contact::contact_exist?(firstname, lastname)
		return $contact["#{firstname}|#{lastname}"].email
	end
end

#
#	return contact's mobile
#
def Contact::get_contact_mobile(firstname, lastname)
	if Contact::contact_exist?(firstname, lastname)
		return $contact["#{firstname}|#{lastname}"].mobile
	end
end

#
#	return contact's im
#
def Contact::get_contact_im(firstname, lastname)
	if Contact::contact_exist?(firstname, lastname)
		return $contact["#{firstname}|#{lastname}"].im
	end
end

#
#	return a table of all contact
#
def get_contact_name()
	name_t=[]
	$contact.each_key {|name|
		name_t.push name
	}
	return name_t
end

def Contact::set_title(firstname, lastname, title)
	$contact["#{firstname}|#{lastname}"].title=title
end

def Contact::set_organization(firstname, lastname, organization)
	$contact["#{firstname}|#{lastname}"].organization=organization
end


def Contact::set_email(firstname, lastname, email)
	$contact["#{firstname}|#{lastname}"].email=email
end

def Contact::set_phone(firstname, lastname, phone)
	$contact["#{firstname}|#{lastname}"].phone=phone
end

def Contact::set_mobile(firstname, lastname, mobile)
	$contact["#{firstname}|#{lastname}"].mobile=mobile
end

def Contact::set_pager(firstname, lastname, pager)
	$contact["#{firstname}|#{lastname}"].pager=pager
end

def Contact::set_im(firstname, lastname, im)
	$contact["#{firstname}|#{lastname}"].im=im
end

def Contact::set_location(firstname, lastname, location)
	$contact["#{firstname}|#{lastname}"].location=location
end

def Contact::set_note(firstname, lastname, note)
	$contact["#{firstname}|#{lastname}"].note=note
end

#
#	check if a contact is defined
#
def Contact::contact_exist?(firstname, lastname)
	return $contact["#{firstname}|#{lastname}"] != nil
end

#
#	return number of contact
#
def Contact::contact_nb_entry()
	return $contact.size
end

###############################################################

	def initialize (fname, lname, email, phone, mobile, im, pager, title=nil, organization=nil, location=nil, note=nil)
		#fnamelname have to be uniq
		@firstname=fname
		@lastname=lname
		@email=email
		@phone=phone
		@mobile=mobile
		@im=im
		@pager=pager
		@title=title
		@organization=organization
		@location=location
		@note=note
		@nb_use=0	
	end

	def Contact::add_use(firstname, lastname)
		$contact["#{firstname}|#{lastname}"].nb_use+=1
		Contact::used?(firstname, lastname)
	end

	def Contact::del_use(firstname, lastname)
		$contact["#{firstname}|#{lastname}"].nb_use-=1
		Contact::used?(firstname, lastname)
	end

	def Contact::used?(firstname, lastname)
		return $contact["#{firstname}|#{lastname}"].nb_use>0 
	end
	
	def to_str()
		print "Contact: ", @firstname, " ", @lastname, " ", @email, " ", @phone, " ", @mobile, " ", @im, " ", @pager, " ", @title, " ", @organization, " ", @location, " ", @note,"\n"
	end

end #class
