#
# here we can find Gtk::Window for add or del an host
#

#
# window to ask in which map to add a node,
# list networks in combobox
# return the network ip
#
def choose_network_map(node_ip, default_map=nil)
  $in_network_map_choice.synchronize {
    choosemap_win = Gtk::Window.new
    choosemap_win.set_transient_for($win)
    choosemap_win.set_title("Choose network map")
    choosemap_win.set_size_request(500, 200)
    choosemap_win.set_modal(true)

    hbox=Gtk::HBox::new   
    frame = Gtk::Frame::new
    frame.border_width=10
    frame.show
    hbox.add frame

    hbox_root=Gtk::HBox::new
    vbox = Gtk::VButtonBox::new

    label_map = Gtk::Label.new "New node at IP #{node_ip} found in local network segment.\nWhere do you want to add it ?"
    entry_map = Gtk::ComboBox.new
    get_network().each { |n|
      entry_map.append_text(n)
    }
    entry_map.prepend_text("Exception list")
    entry_map.set_active(1)
    if !default_map.nil? and !default_map.empty?
      ind = get_network().index(default_map)
      entry_map.set_active(ind) if ind
    end
    bbox=Gtk::HButtonBox.new  
    ok_button = Gtk::Button.new(Gtk::Stock::OK)
    ok_button.signal_connect("clicked") {
      result = entry_map.active_text
      choosemap_win.destroy
      $network_map_result = result
    }
    cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
    cancel_button.signal_connect("clicked") {
      choosemap_win.destroy
      $network_map_result = ""
    }
    
    choosemap_win.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      choosemap_win.destroy
      $network_map_result = ""
    end
    }
    
    check_map = Gtk::CheckButton.new("Always map to this network")
    if $network_map_always == 1
      check_map.set_active true
    else
      check_map.set_active false    
    end
    check_map.signal_connect("toggled") {
      # we don't care of the box is checked when the map is set to exception
        $network_map_always = check_map.active? ? 1 : 0        
    }
    
    bbox.add ok_button
    bbox.add cancel_button
    bbox.show_all

    vbox.add label_map
    vbox.add entry_map
    vbox.add check_map
    vbox.add bbox
    hbox_root.add Gtk::Image.new(Gtk::Stock::DIALOG_QUESTION, Gtk::IconSize::DIALOG)
    hbox_root.add vbox
    frame.add hbox_root
    choosemap_win.add hbox
    choosemap_win.show_all
  }
end

#
# error window
#
def errorEntry(win, ent)
      lbl="You have to fill at least IP or DNS name"
      if ent != ""
	      lbl="Error: '#{ent}'"
      end
      dialog = Gtk::MessageDialog.new(win, Gtk::Dialog::DESTROY_WITH_PARENT,
                        	Gtk::MessageDialog::ERROR,
                        	Gtk::MessageDialog::BUTTONS_OK,
                        	lbl)

	dialog.set_icon("#{PIXMAP_PATH}/logo_icon.png")
	dialog.run
	dialog.destroy
end

#
# window to add an host
#
def addnodewin()

  if $win == nil
    return
  end

  addwin=Gtk::Window.new
  addwin.set_transient_for($win)
  addwin.set_title("Node host adding")
  addwin.set_size_request(350, 270)
  addwin.set_modal(true)

  addwin.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      addwin.destroy
    end
  }

  frame = Gtk::Frame::new("Add an host")
  frame.border_width=10
  frame.show
  vbox_root=Gtk::VBox::new
  vbox_root.show
  addwin.add vbox_root
  vbox_root.add frame

  vbox = Gtk::VBox.new
  vbox.show
  frame.add vbox

  table = Gtk::Table.new(8,2,false)
  table.show

  label_icon = Gtk::Label.new "Icon"
  label_icon.show

  ent =  Gtk::ImageComboList.new("type", "host")
  ent.show

  table.attach(label_icon,0,1,0,1)
  table.attach(ent,1,2,0,1)

  #set_editable set_visibility set_sensitive set_text
  entry_ip = Gtk::Entry.new
  entry_ip.show

  label_ip = Gtk::Label.new "IP"
  label_ip.show

  table.attach(label_ip,0,1,1,2)
  table.attach(entry_ip,1,2,1,2)

  hbox = Gtk::HBox.new
  hbox.show
  entry_netmask = Gtk::Entry.new
  entry_netmask.set_text DEFAULT_CLASS_C_NETMASK
  entry_netmask.set_editable false
  entry_netmask.show

  adj = Gtk::Adjustment::new(0, 1.0, 32.0, 1.0, 5.0, 0.0)
  compressnetmask = Gtk::SpinButton::new(adj, 0, 0)
  compressnetmask.set_wrap(true)
  compressnetmask.set_editable false
  compressnetmask.set_value 24.0

  compressnetmask.show
  hbox.add entry_netmask
  hbox.add compressnetmask
  label_netmask = Gtk::Label.new "Mask"
  label_netmask.show
  table.attach(label_netmask,0,1,2,3)
  table.attach(hbox,1,2,2,3)

  compressnetmask.signal_connect("value-changed") {
    entry_netmask.set_text bit2netmask(compressnetmask.value_as_int)
  }

  entry_name = Gtk::Entry.new
  #entry_name.select_region(0, 5)
  entry_name.show

  label_name = Gtk::Label.new "DNS name"
  label_name.show

  table.attach(label_name,0,1,3,4)
  table.attach(entry_name,1,2,3,4)

  label_map = Gtk::Label.new "Map"
  label_map.show
  entry_map = Gtk::ComboBox.new
  get_network().each { |n|
    entry_map.append_text(n)
  }
  if get_map() != nil
    ind = get_network().index(get_map())
    entry_map.set_active(ind) if ind
  end
  entry_map.show

  table.attach(label_map,0,1,4,5)
  table.attach(entry_map,1,2,4,5)

  entry_description = Gtk::Entry.new
  #entry_description.select_region(0, 5)
  entry_description.show
  label_description = Gtk::Label.new "Description"
  label_description.show

  table.attach(label_description,0,1,5,6)
  table.attach(entry_description,1,2,5,6)

  bbox =Gtk::HBox::new(FALSE, 10)
  bbox.border_width=10
  bbox.show

  ok_button = Gtk::Button.new(Gtk::Stock::OK)
  ok_button.show
  ok_button.signal_connect("clicked") {
    nnode_pix_os = "os/unknown.png"
    if ent.filename == nil
      nnode_type = "pc"
    else
      nnode_type_t = ent.filename.match('^.+\/(.+)\..*$')
      nnode_type=nnode_type_t[1]
    end

    if isValidIPv4(entry_ip.text) or (entry_name.text != "")
      if (entry_ip.text == "") and (entry_name.text != "")
        #we will try to resolve the name
        ip_from_name = ""
        begin
          ip_from_name = Resolv.getaddress entry_name.text
        rescue Exception => msg
          errorEntry(addwin, msg)
          next
        end
        entry_ip.text = ip_from_name if ip_from_name
      end
      if entry_name.text == ""
        entry_name.set_text Node::NONAME_PROPERTY
      end

      if entry_description.text == ""
        entry_description.set_text Node::NODESCR_PROPERTY
      end

      lentry=entry_ip.text.split(/\./)
      if lentry[3] == "0" || lentry[3] == "255"
        #add a network
        $log.info("Seems that it's a network! Trying to add it")
        mask=compressnetmask.value_as_int
        tfindremotehost(entry_ip.text,mask)
        addwin.destroy
      else
        if !$host[entry_ip.text]
          #we dont use add_host, here we can set more attribute
          $host[entry_ip.text]=Host.new(entry_ip.text,compressnetmask.value_as_int,nil,nil,entry_map.active_text,Node::NOARP_PROPERTY,entry_name.text,Node::NONAME_PROPERTY,nil,UNKNOWN,0,0, nnode_pix_os,entry_description.text,nnode_type,"unknown")
          $network[entry_map.active_text].add_host($host[entry_ip.text])
          $network[entry_map.active_text].update_status()
          $host[entry_ip.text].reload()
          #now we need to force node view drawing
          $host[entry_ip.text].node_view.show() if entry_map.active_text==get_map()
          $event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", $host[entry_ip.text], "Host added")
          #$network[entry_map.active_text].update_status()
          addwin.destroy
        else
          errorEntry(addwin, "Host already exists")
        end
      end
    else
      errorEntry(addwin, entry_ip.text)
    end
  }

  cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
  cancel_button.show
  cancel_button.signal_connect("clicked") {
    addwin.destroy
  }

  ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(ok_button, TRUE, TRUE, 0)
  cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(cancel_button, TRUE, TRUE, 0)

  vbox.add(table)
  separator = Gtk::HSeparator::new()
  separator.show
  vbox_root.pack_start(separator, FALSE, TRUE, 0)
  vbox_root.pack_start(bbox, FALSE, TRUE, 0)


  addwin.show
end

#
# window to delete an host
#
def verify_delnodewin(node)
  
	#test if is not the root network
	if !node || (node.map == nil)
		return
	end

	mode=1
	if node.class == Array
		#multiple nodes!
		mode=2
	end

  if $config.confirm_delete
	  label=""
	  if mode == 1
		  if node.ip == ""
   		 label = "Do you really want to delete this node ?"
		  else
   		 label = "Do you want to delete '#{node.ip}' ?"
		  end
		else
			#test if there more than 1 node in the array
			if node.size > 1
				label = "Do you really want to delete these nodes ?"
			else
				label = "Do you want to delete '#{node[0].ip}' ?"		
			end
     end
     dialog = Gtk::MessageDialog.new($win, Gtk::Dialog::DESTROY_WITH_PARENT,
                           	 Gtk::MessageDialog::QUESTION,
                           	 Gtk::MessageDialog::BUTTONS_YES_NO,
                           	 label)
	  dialog.run do |r|
		  dialog.destroy
		  if r == Gtk::Dialog::RESPONSE_YES then
			  if mode == 1
   			$event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", node, "Host removed")
   			node.delete()
			   #update map
			   #$network[node.map].update_status()
			  else
				  node.each {|n|
   				 $event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", n, "Host removed")
   				 n.delete()
				  }
			  	  #$network[n[0].map].update_status() unless n[0] == nil
			  end
			  return 1
		  end
	  end
	else
		#dont show confirm popup and delete anyway
		if mode == 1
   	 $event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", node, "Host removed")
   	 node.delete()
		else
			node.each {|n|
   		  $event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", n, "Host removed")
   		  n.delete()
			}
		end
		return 1
	end
	return 0
end

#
# window to add a range of host node
#
def add_host_range()
    if $win == nil
  	    return
    end

    addwin=Gtk::Window.new
    addwin.set_transient_for($win)
    addwin.set_title("Node host range adding")
    addwin.set_size_request(350, 150)
    addwin.set_modal(true)

   addwin.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
			addwin.destroy
      end
    }

    frame = Gtk::Frame::new("Add host range")
    frame.border_width=10
    frame.show
    vbox_root=Gtk::VBox::new
    vbox_root.show
    addwin.add vbox_root
    vbox_root.add frame
    vbox = Gtk::VBox.new
    vbox.show
    frame.add vbox

    table = Gtk::Table.new(3,2,false)
    table.show

    hostalivetoo = Gtk::CheckButton.new("Add alive hosts in range")
    hostalivetoo.show

    label_ip = Gtk::Label.new "IP"
    label_ip.show

    hbox = Gtk::HBox.new
    hbox.show
    entry_ip = Gtk::Entry.new
	 entry_ip.show
    entry_ip_end = Gtk::Entry.new
	 entry_ip_end.set_size_request(10,-1)
	 entry_ip_end.show
	 hbox.add entry_ip
	 hbox.add entry_ip_end

    table.attach(label_ip,0,1,0,1)
    table.attach(hbox,1,2,0,1)

    ok_button = Gtk::Button.new(Gtk::Stock::OK)
    ok_button.show
    ok_button.signal_connect("clicked") {

    if isValidIPv4(entry_ip.text) && isInteger(entry_ip_end.text)

       if hostalivetoo.active?
    	   tfindrangeremotehost(entry_ip.text, entry_ip_end.text)
       else
	    	lentry=entry_ip.text.split(/\./)
			ip_addr="#{lentry[0]}.#{lentry[1]}.#{lentry[3]}."	
			limit_inf=lentry[3].to_i()
			limit_sup=entry_ip_end.text.to_i()
			if limit_inf > limit_sup
				limit_tmp=limit_inf
				limit_inf=limit_sup
				limit_sup=limit_tmp
			end
			for ip in limit_inf..limit_sup
 	   		add_host(ip_addr+"#{ip}", 24, get_map())
			end
			#$network[get_map()].update_status()
       end
       addwin.destroy 
    else
		 if isInteger(entry_ip_end.text)
  	    	errorEntry(addwin, entry_ip.text)
		 else
  	    	errorEntry(addwin, entry_ip_end.text)
		 end
    end
    }

    cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
    cancel_button.show
    cancel_button.signal_connect("clicked") {
  	    addwin.destroy 
    }

	 bbox =Gtk::HBox::new(FALSE, 10)
	 bbox.border_width=10
	 bbox.show

	 ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(ok_button, TRUE, TRUE, 0)
	 cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(cancel_button, TRUE, TRUE, 0)

	 vbox.add(table)
	 vbox.add hostalivetoo
	 separator = Gtk::HSeparator::new()
	 separator.show
	 vbox_root.pack_start(separator, FALSE, TRUE, 0)
	 vbox_root.pack_start(bbox, FALSE, TRUE, 0)

    addwin.show
end

#
# window to add a network
#
def addnetworkwin()
  if $win == nil
    return
  end

  addwin=Gtk::Window.new
  addwin.set_transient_for($win)
  addwin.set_title("Node network adding")
  addwin.set_size_request(350, 200)
  addwin.set_modal(true)

  addwin.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      addwin.destroy
    end
  }

  frame = Gtk::Frame::new("Add Network")
  frame.border_width=10
  frame.show
  vbox_root=Gtk::VBox::new
  vbox_root.show
  addwin.add vbox_root
  vbox_root.add frame
  vbox = Gtk::VBox.new
  vbox.show
  frame.add vbox

  table = Gtk::Table.new(3,2,false)
  table.show

  hostalivetoo = Gtk::CheckButton.new("Add alive host in network")
  hostalivetoo.show

  label_ip = Gtk::Label.new "IP / Domain"
  label_ip.show
  entry_ip = Gtk::Entry.new
  entry_ip.show

  table.attach(label_ip,0,1,0,1)
  table.attach(entry_ip,1,2,0,1)
  label_netmask = Gtk::Label.new "Netmask"
  label_netmask.show

  hbox = Gtk::HBox.new
  hbox.show
  entry_netmask = Gtk::Entry.new
  entry_netmask.set_text DEFAULT_CLASS_C_NETMASK
  entry_netmask.set_editable false
  entry_netmask.show

  adj = Gtk::Adjustment::new(0, 1.0, 32.0, 1.0, 5.0, 0.0)
  compressnetmask = Gtk::SpinButton::new(adj, 0, 0)
  compressnetmask.set_wrap(true)
  compressnetmask.set_editable false
  compressnetmask.set_value 24.0

  compressnetmask.show
  hbox.add entry_netmask
  hbox.add compressnetmask
  table.attach(label_netmask,0,1,1,2)
  table.attach(hbox,1,2,1,2)

  entry_ip.signal_connect("changed") {
    if entry_ip.text.match /^[\.\d]+$/
      hbox.set_sensitive(true)
    else
      hbox.set_sensitive(false)
    end
  }

  compressnetmask.signal_connect("value-changed") {
    entry_netmask.set_text bit2netmask(compressnetmask.value_as_int)
  }

  ok_button = Gtk::Button.new(Gtk::Stock::OK)
  ok_button.show
  ok_button.signal_connect("clicked") {
    if isValidIPv4(entry_ip.text)
      lentry=entry_ip.text.split(/\./)
      if !$network[entry_ip.text]
        if hostalivetoo.active?
          tfindremotehost(entry_ip.text,compressnetmask.value_as_int)
        else
          add_network(entry_ip.text, compressnetmask.value_as_int, get_map())
        end
        addwin.destroy
      else
        errorEntry(addwin, "Network already exists")
      end
    else
      #it may be a domainname
      ip_from_domain = ""
      begin
        ip_from_domain = Resolv.getaddress entry_ip.text
        #transfor this ip in at least a class C
        ip_from_domain.gsub! /\.\d+$/,".0"
      rescue Exception => msg
        errorEntry(addwin, msg)
        next
      end
      if !$network[ip_from_domain]
        add_network(ip_from_domain, 24, get_map())
      else
        errorEntry(addwin, "Network already exists")
      end
      if hostalivetoo.active?
        dns = Resolv::DNS.new
        
        resource_type=Resolv::DNS::Resource::IN::ANY
        if RUBY_VERSION.match("^1\.8")
          #only A type for ruby 1.8 as ANY is not working
          resource_type=Resolv::DNS::Resource::IN::A
        end
        
        dns.getresources(entry_ip.text, resource_type).collect do |r|
          if r.kind_of?(Resolv::DNS::Resource::IN::MX) or r.kind_of?(Resolv::DNS::Resource::IN::A) or r.kind_of?(Resolv::DNS::Resource::IN::AAAA) or r.kind_of?(Resolv::DNS::Resource::IN::NS) then
            begin
              ip_from_name = ""
	      name = ""
              if r.kind_of?(Resolv::DNS::Resource::IN::MX)
	        name = r.exchange.to_s.strip
                ip_from_name = Resolv.getaddress name
              elsif r.kind_of?(Resolv::DNS::Resource::IN::A)
                ip_from_name = r.address.to_s.strip
              elsif r.kind_of?(Resolv::DNS::Resource::IN::NS)
	        name = r.name.to_s.strip
                ip_from_name = Resolv.getaddress name
              end
              if !$host[ip_from_name]
                add_host(ip_from_name, 24, ip_from_domain)
		if $host[ip_from_name]
		  if r.kind_of?(Resolv::DNS::Resource::IN::MX)
		    $host[ip_from_name].add_service("tcp", 25, "", 0, 0)
		  elsif r.kind_of?(Resolv::DNS::Resource::IN::NS)
		    $host[ip_from_name].add_service("udp", 53, "", 0, 0)		  
		  end
		  if name != ""
		    $host[ip_from_name].dns_name = name
		  end
		end
              else
                errorEntry(addwin, "Host already exists")
              end
            rescue Exception => msg
              errorEntry(addwin, msg)
              next
            end
          end
        end
      end
      addwin.destroy
    end
  }

  cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
  cancel_button.show
  cancel_button.signal_connect("clicked") {
    addwin.destroy
  }

  bbox =Gtk::HBox::new(FALSE, 10)
  bbox.border_width=10
  bbox.show

  ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(ok_button, TRUE, TRUE, 0)
  cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(cancel_button, TRUE, TRUE, 0)

  vbox.add(table)
  vbox.add hostalivetoo
  separator = Gtk::HSeparator::new()
  separator.show
  vbox_root.pack_start(separator, FALSE, TRUE, 0)
  vbox_root.pack_start(bbox, FALSE, TRUE, 0)

  addwin.show
end

#
# delete node window
#
def delnodewin()
    if $win == nil
  	    return
    end

    delwin=Gtk::Window.new
    delwin.set_transient_for($win)
    delwin.set_title("Node deleting")
    delwin.set_size_request(250, 160)
    delwin.set_modal(true)

    delwin.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
			delwin.destroy
      end
    }

    frame = Gtk::Frame::new("Del Node")
    frame.border_width=10
    frame.show
    vbox_root=Gtk::VBox::new
    vbox_root.show
    delwin.add vbox_root
    vbox_root.add frame
    vbox = Gtk::VBox.new
    vbox.show
    frame.add vbox

    table = Gtk::Table.new(3,2,false)
	 table.set_row_spacings(5)
	 table.set_size_request(-1,15)
    table.show

    label_type = Gtk::Label.new "Type"
    label_type.show
	 combo_type=Gtk::ComboBox.new
	 combo_type.append_text("Host")
	 combo_type.append_text("Network")
	 combo_type.set_active(0)
  	 combo_type.show

    table.attach(label_type,0,1,0,1)
    table.attach(combo_type,1,2,0,1)

    label_value = Gtk::Label.new "Value"
    label_value.show
	 combo_value=Gtk::ComboBox.new
	 $host.each_value do |node|
		 combo_value.append_text(node.ip)
	 end
	 combo_value.set_active(0)
  	 combo_value.show

    table.attach(label_value,0,1,1,2)
    table.attach(combo_value,1,2,1,2)
	
	combo_type.signal_connect("changed") do |combo|
		case combo.active_text
			when "Host" then
				for ind in 0..$network.size()-2
					combo_value.remove_text(0)
				end
				$host.each_value do |node|
					combo_value.append_text(node.ip)
	 			end
				combo_value.set_active(0)
			when "Network" then
				for ind in 0..$host.size()-1
					combo_value.remove_text(0)
				end
				#need to test in which map we are
				network_list=[]
				#contain path to map in which we are
				map_list=[]
				map_current=get_map()	
				begin
				  map_list.push map_current
				  map_current=$network[map_current].map
				end until map_current == nil

				$network.each_value do |node|
					 network_list.push(node.ip)
	 			end
	 			(network_list - map_list).each do |val|
                  combo_value.append_text(val)
	 			end
				combo_value.set_active(0)
		end
 	end
    del_button = Gtk::Button.new(Gtk::Stock::REMOVE)
    del_button.show
    del_button.signal_connect("clicked") {
		case combo_type.active_text
			when "Host" then
			    if combo_value.active_text != nil
    				if verify_delnodewin($host[combo_value.active_text]) == 1
   	            combo_value.remove_text(combo_value.active)
	    				combo_value.set_active(0)
					end
				end
			when "Network" then
			    if combo_value.active_text != nil
					if verify_delnodewin($network[combo_value.active_text]) == 1
                  combo_value.remove_text(combo_value.active)
      				combo_value.set_active(0)
					end
  				end
		end
    }

    close_button = Gtk::Button.new(Gtk::Stock::CLOSE)
    close_button.show
    close_button.signal_connect("clicked") {
  	    delwin.destroy 
    }

	 bbox =Gtk::HBox::new(FALSE, 10)
	 bbox.border_width=10
	 bbox.show

	 del_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(del_button, TRUE, TRUE, 0)
	 close_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	 bbox.pack_start(close_button, TRUE, TRUE, 0)

	 vbox.pack_start(table, FALSE, TRUE)
	 separator = Gtk::HSeparator::new()
	 separator.show
	 vbox_root.pack_start(separator, FALSE, TRUE, 0)
	 vbox_root.pack_start(bbox, FALSE, TRUE, 0)

   delwin.show
end

#
# unwanted node window
#
def unwantednodewin()
  if $win == nil
    return
  end
  
  unwtdwin=Gtk::Window.new
  unwtdwin.set_transient_for($win)
  unwtdwin.set_title("Unwanted node")
  unwtdwin.set_size_request(250, 160)
  unwtdwin.set_modal(true)

  unwtdwin.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      unwtdwin.destroy
    end
  }

  frame = Gtk::Frame::new("Del exception")
  frame.border_width=10
  frame.show
  vbox_root=Gtk::VBox::new
  vbox_root.show
  unwtdwin.add vbox_root
  vbox_root.add frame
  vbox = Gtk::VBox.new
  vbox.show
  frame.add vbox

  table = Gtk::Table.new(2,2,false)
  table.set_row_spacings(5)
  table.set_size_request(-1,15)
  table.show

  label_value = Gtk::Label.new "Value"
  label_value.show
  combo_value=Gtk::ComboBox.new
  $node_exception_list.sort.each do |str|
    combo_value.append_text(str)
  end
  combo_value.set_active(0)
  combo_value.show

  table.attach(label_value,0,1,0,1)
  table.attach(combo_value,1,2,0,1)
  
  label_map_exception = Gtk::Label.new "Always map new node"
  label_map_exception.show
  check_map = Gtk::CheckButton.new
  if $network_map_always == 1
    check_map.set_active true
  else
    check_map.set_active false    
  end
  check_map.show
  check_map.signal_connect("toggled") {
    $network_map_always = check_map.active? ? 1 : 0        
  }

  table.attach(check_map,0,1,1,2)
  table.attach(label_map_exception,1,2,1,2)  
  
  del_button = Gtk::Button.new(Gtk::Stock::REMOVE)
  del_button.show
  del_button.signal_connect("clicked") {
    if combo_value.active >= 0
      del_node_def_exception_list(combo_value.active_text)
      combo_value.remove_text(combo_value.active)
      combo_value.set_active(0)
    end
  }

  close_button = Gtk::Button.new(Gtk::Stock::CLOSE)
  close_button.show
  close_button.signal_connect("clicked") {
    unwtdwin.destroy
  }

  bbox =Gtk::HBox::new(FALSE, 10)
  bbox.border_width=10
  bbox.show

  del_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(del_button, TRUE, TRUE, 0)
  close_button.set_flags(Gtk::Widget::CAN_DEFAULT)
  bbox.pack_start(close_button, TRUE, TRUE, 0)

  vbox.pack_start(table, FALSE, TRUE)
  separator = Gtk::HSeparator::new()
  separator.show
  vbox_root.pack_start(separator, FALSE, TRUE, 0)
  vbox_root.pack_start(bbox, FALSE, TRUE, 0)

  unwtdwin.show
end
