=begin header

  base window

=end

require "#{GNMSLIB}"+'/gui/help_window'
require "#{GNMSLIB}"+'/gui/update_window'
require "#{GNMSLIB}"+'/gui/oid_ref_window'
require "#{GNMSLIB}"+'/gui/wmi_ref_window'
require "#{GNMSLIB}"+'/gui/jmx_ref_window'
require "#{GNMSLIB}"+'/gui/syslog_ref_window'
require "#{GNMSLIB}"+'/gui/snmptrap_ref_window'
require "#{GNMSLIB}"+'/gui/custom_plugin_window'
require "#{GNMSLIB}"+'/gui/mib_browser'
require "#{GNMSLIB}"+'/gui/about_window'
require "#{GNMSLIB}"+'/gui/find_node_window'
require "#{GNMSLIB}"+'/gui/color_macro'
require "#{GNMSLIB}"+'/gui/treenode_window'
require "#{GNMSLIB}"+'/gui/ipcalculator'
require "#{GNMSLIB}"+'/monitor/custom_plugin'
require "#{GNMSLIB}"+'/config_global'
require "#{GNMSLIB}"+'/node_db'

#default network map where to add new nodes
$network_map_always = 0
$network_map_result = nil
$in_network_map_choice = Mutex.new


#we load plugins rb files
lfile = Dir["#{PLUGIN_DIR}/*.rb"]
lfile.sort!
cptCustomMon=0
$plugin_name_list = []
for pluginsfile in lfile
	begin
	require pluginsfile

	pluginsfile=pluginsfile[PLUGIN_DIR.length+1,pluginsfile.size - PLUGIN_DIR.length - 1 - 3]
	cmd="#{pluginsfile[0,1].capitalize()}#{pluginsfile[1,pluginsfile.size - 1]}"
	if (eval cmd).superclass==CustomPlugin
		cptCustomMon+=1
	        #create custom monitor table if needed
		if !defined?($custom_monitor)
			$custom_monitor=[]
		end
		#add custom monitor into array
		$custom_monitor.push(cmd)
	else
		$plugin_name_list.push(cmd)
	end
	rescue Exception => msg
		$log.info("Error when loading #{pluginsfile} custom monitor plugin: #{msg}")
		next
	end
	
end

if cptCustomMon>0
   $log.info("Find #{cptCustomMon} custom monitor plugin" + (cptCustomMon>1?"s":""))
end

class App < Gtk::Window

def N_ (text)
	return text
end

def busy()
   @busy = 1
   self.disable_menu()
   self.window.cursor = Gdk::Cursor.new(Gdk::Cursor::WATCH) if self.window
end

def unbusy()
   @busy = 0
   self.enable_menu()
   self.window.cursor = nil if self.window
end

def busy?()
   return @busy == 1
end

def set_map_display_view_user_defined()
	$config.map_display_view="User defined"
end

def hide_menu_entry()
	@ag.get_action("AddMenu").sensitive=false
end

def show_menu_entry()
	@ag.get_action("AddMenu").sensitive=true
end

def hide_update_menu_entry()
	@ag.get_action("Update").sensitive=false
end

def show_update_menu_entry()
	@ag.get_action("Update").sensitive=true
end

def hide_menu()
	@main_vbox.remove(@main_bar)
end

def disable_menu()
	@main_bar.set_sensitive(false) if @main_bar
end

def enable_menu()
	@main_bar.set_sensitive(true) if @main_bar
end

def show_menu()
	@main_bar.height_request=30
	@main_vbox.pack_start(@main_bar,false)
	@main_vbox.reorder_child(@main_bar,0)
end

def check_update()
	check_update_window()
end

def set_display_view_menu()
	@ag.get_action("User defined").activate
end

def get_size_changed_from_menu()
	return @size_changed_from_menu
end

def set_size_changed_from_menu(b)
	@size_changed_from_menu=b
end

def initialize(title)

    super(title)
    @size_changed_from_menu=false
    @busy = 0

    pluginslist=[]
    create_plugins_list(pluginslist)

proc_map_window=Proc.new {|action, current|
	@size_changed_from_menu=true
	$config.map_display_view=current.name
	if current.name == "25% screen"
		map_window_activ_quart()
	elsif current.name == "50% screen"
		map_window_activ_half()
	elsif current.name == "100% screen"
		map_window_activ_full()
	elsif current.name == "Full screen"
		$canvas.toggle_fullscreen()
	end
}

proc_icon=Proc.new  {|action, current|
	if current.name.index("host")
	  if current.name == "host_type"
		 $config.host_icon_view="type"
	  	 host_icon()
	  else
		 $config.host_icon_view="os"
	  	 host_icon()
	  end
	else
		if current.name == "network_type"
			$config.network_icon_view="type"
			network_icon()
		else
			$config.network_icon_view="os"
			network_icon()
		end
	end
}

proc_label=Proc.new {|action, current|
	if current.name.index("host")
		if current.name == "host_dns_name"
			 $config.host_label_view="dns_name"
			 host_label()
		 elsif current.name == "host_netbios_name"
			 $config.host_label_view="netbios_name"
			 host_label()
		 elsif current.name == "host_ip"
			 $config.host_label_view="ip"
			 host_label()
		 elsif current.name == "host_osl"
		    $config.host_label_view="os"
			 host_label()
		 elsif current.name == "host_mac"
			 $config.host_label_view="mac"
			 host_label()
		 elsif current.name == "host_mac_manufacturer"
			 $config.host_label_view="mac_manufacturer"
			 host_label()
		 elsif current.name == "host_description"
			 $config.host_label_view="description"
			 host_label()
		 end
	else
		case current.name
		when "network_name"
			$config.network_label_view="name"
			network_label()
		when "network_dns_domain"
		   $config.network_label_view="dns_domain"
			network_label()
		when "network_netbios_domain"
	 	   $config.network_label_view="netbios_domain"
			network_label()
		when "network_ip"
	 	 	$config.network_label_view="ip"
			network_label()
		when "network_osl"
    		$config.network_label_view="os"
			network_label()
		when "network_description"
			$config.network_label_view="description"
			network_label()
		end
	end
}

plugins_list_xml=""
pluginslist.each {|plugin_name_table|
	plugins_list_xml="#{plugins_list_xml}\n<menuitem action='#{plugin_name_table[0]}'/>"
}

main_menu = %Q[
<ui>
  <menubar name='MainBar'>
    <menu action='FileMenu'>
      <menuitem action='Open backup file'/>
      <menuitem action='Save log'/>
      <menuitem action='Save map'/>
      <menuitem action='Save map as XML'/>
      <menuitem action='Snapshot'/>
      <separator/>
      <menuitem action='Reset'/>
      <separator/>
      <menuitem action='Quit'/>
    </menu>
    <menu action='ViewMenu'>
		<menu action='LabelMenu'>
      	<menu action='LabelHostMenu'>
				<menuitem action='host_dns_name'/>
				<menuitem action='host_netbios_name'/>
				<menuitem action='host_ip'/>
				<menuitem action='host_osl'/>
				<menuitem action='host_mac'/>
				<menuitem action='host_mac_manufacturer'/>
				<menuitem action='host_description'/>
      	</menu>
      	<menu action='LabelNetworkMenu'>
				<menuitem action='network_name'/>
				<menuitem action='network_dns_domain'/>
				<menuitem action='network_netbios_domain'/>
				<menuitem action='network_ip'/>
				<menuitem action='network_osl'/>
				<menuitem action='network_description'/>
      	</menu>
		</menu>
		<menu action='IconMenu'>
      	<menu action='IconHostMenu'>
				<menuitem action='host_osi'/>
				<menuitem action='host_type'/>
      	</menu>
      	<menu action='IconNetworkMenu'>
				<menuitem action='network_osi'/>
				<menuitem action='network_type'/>
      	</menu>
		</menu>
      <separator/>
      <menuitem action='Select all nodes'/>
      <menuitem action='Switch selected nodes'/>
      <separator/>
      <menuitem action='Zoom in'/>
      <menuitem action='Zoom out'/>
       <menu action='MapWindowMenu'>
        <menuitem action='User defined'/>
        <menuitem action='25% screen'/>
        <menuitem action='50% screen'/>
        <menuitem action='100% screen'/>
        <menuitem action='Full screen'/>
       </menu>     
      </menu>
	 <menu action='ManageMenu'>
      <menu action='AddMenu'>
      	<menuitem action='Add host'/>
      	<menuitem action='Add host range'/>
      	<menuitem action='Add network'/>
      </menu>
      <menuitem action='Del node'/>
      <separator/>
      <menuitem action='Unwanted node'/>
    </menu>
    <menu action='OptionMenu'>
      <menuitem action='Preference'/>
      <menu action='EventConfMenu'>
      	<menuitem action='SNMP OID conf'/>
      	<menuitem action='SNMP Trap conf'/>
      	<menuitem action='WMI Request conf'/>
      	<menuitem action='JMX Ref conf'/>
      	<menuitem action='Syslog Ref conf'/>
      	<menuitem action='Custom conf'/>	
      </menu>
    </menu>
    <menu action='ToolsMenu'>
      <menuitem action='Node Tree'/>
      <menuitem action='Node Find'/>
      <menuitem action='Event browser'/>
      <menuitem action='MIB browser'/>
      <menuitem action='IP calculator'/>
    </menu>
    <menu action='PluginMenu'>
#{plugins_list_xml}
    </menu>
    <menu action='HelpMenu'>
      <menuitem action='Help'/>
      <menuitem action='Update'/>
      <menuitem action='About...'/>
    </menu>
  </menubar>
</ui>]

#we need to have an action_procs!
@action_procs=actions = [
  ["FileMenu", nil, "_File"],
  ["Open backup file", Gtk::Stock::OPEN, "_Open backup file", "<control>O", "Open backup file", proc{ open_file }],
  ["Save log", Gtk::Stock::SAVE, "Save _Log", "<control>L", "Save current log", proc{ $event_win.save_event() }],
  ["Save map", Gtk::Stock::SAVE, "_Save Map", "<control>S", "Save map", proc{ save }],
  ["Save map as XML", Gtk::Stock::SAVE, "Save Map As _XML", "<control>X", "Save map to a file", proc{ save_as }],
  ["Snapshot", Gtk::Stock::PRINT, "Snap Shot", nil, "Take a snapshot", proc{ snapshot }],
  ["Reset", Gtk::Stock::NEW, "_Reset", "<control>R", "Create a new map", proc{ new_map }],
  ["Quit", Gtk::Stock::QUIT, "_Quit", "<control>Q", "Quit", proc{ quit_now }],
  ["ViewMenu", nil, "View"],
  ["LabelMenu", nil, "Node label"],
  ["IconMenu", nil, "Node icon"],
  ["LabelHostMenu", nil, "Host as"],
  ["IconHostMenu", nil, "Host as"],
  ["LabelNetworkMenu", nil, "Network as"],
  ["IconNetworkMenu", nil, "Network as"],
  ["Select all nodes", nil, "Select _all nodes", "<control>A", "", proc { select_all_node() }],
  ["Switch selected nodes", nil, "Sw_itch selected nodes", "<control>I", "", proc { invert_selected_node() }],
  ["Zoom in", Gtk::Stock::ZOOM_IN, "Zoom in", "KP_Add", "", proc { $canvas.node_view_zoom_in() }],
  ["Zoom out", Gtk::Stock::ZOOM_OUT, "Zoom out", "KP_Subtract", "", proc { $canvas.node_view_zoom_out() }],
  ["MapWindowMenu", nil, "Map window"],
  ["ManageMenu", nil, "Manage"],
  ["AddMenu", Gtk::Stock::ADD, "Add node"],
  ["Add host", nil, "Host", nil, "", proc { addnodewin }],
  ["Add host range", nil, "Host range", nil, "", proc { add_host_range }],
  ["Add network", nil, "Network", nil, "", proc { addnetworkwin }],
  ["Del node", Gtk::Stock::REMOVE, "Del node", nil, "", proc { delnodewin }],
  ["Unwanted node", Gtk::Stock::PREFERENCES, "Unwanted node", nil, "", proc { unwantednodewin }],  
  ["OptionMenu", nil, "Option"],
  ["Preference", Gtk::Stock::PREFERENCES, "Preference", nil, "", proc { create_config_option } ],
  ["EventConfMenu", nil, "Monitoring conf"],
  ["SNMP OID conf", nil, "SNMP OID", "", "", proc { OIDRefWindow.new() }],
  ["WMI Request conf", nil, "WMI Request", "", "", proc { WMIRefWindow.new() }],
  ["Syslog Ref conf", nil, "Syslog Event", "", "", proc { SyslogRefWindow.new() }],
  ["SNMP Trap conf", nil, "SNMP Trap", "", "", proc { SnmpTrapRefWindow.new() }],
  ["JMX Ref conf", nil, "JMX Request", "", "", proc { JMXRefWindow.new() }],
  ["Custom conf", nil, "Custom Plugin", "", "", proc { CustomPluginWindow.new() }],  
  ["ToolsMenu", nil, "Tools"],
  ["Node Tree", nil, "Node _Tree", "<control>T", "", proc { $treenode_win.show() }],
  ["Node Find", Gtk::Stock::FIND, "Node _Find", "<control>F", "", proc { findnodewin }],
  ["Event browser", nil, "_Event browser", "<control>E", "", proc { $event_win.show() }],
  ["MIB browser", nil, "_MIB browser", "<control>M", "", proc { MibBrowser.new }],
  ["IP calculator", nil, "IP _calculator", "<control>C", "", proc { netmask_calculator} ],
  ["PluginMenu", nil, "Plugins"],
  ["HelpMenu", nil, "Help"],
  ["Help", Gtk::Stock::HELP, "Help", nil, "", proc{ create_help }],
  ["Update", Gtk::Stock::HOME, "Check update", nil, "", proc{ check_update }],
  ["About...", Gtk::Stock::ABOUT, "About", nil, "About", proc{ AboutWindow.new }]
]
$log.info("#{pluginslist.length()} plugin" + (pluginslist.length()>1?"s":"") + " loaded")
if pluginslist.length()
	actions=actions+pluginslist
end

map_window_radio_actions = [
  ["User defined", nil, "User defined", nil, "User defined", 0],
  ["25% screen", nil, "25% screen", nil, "25% screen", 1],
  ["50% screen", nil, "50% screen", nil, "50% screen", 2],
  ["100% screen", nil, "100% screen", nil, "100% screen", 3],
  ["Full screen", nil, "Full screen", nil, "Full screen", 4]
]

node_host_label_radio_actions = [
  ["host_dns_name", nil, "DNS Name", nil, "DNS Name", 0],
  ["host_netbios_name", nil, "Netbios Name", nil, "Netbios Name", 1],
  ["host_ip", nil, "IP", nil, "IP", 2],
  ["host_osl", nil, "OS", nil, "OS", 3],
  ["host_mac", nil, "MAC", nil, "MAC", 4],
  ["host_mac_manufacturer", nil, "MAC manufacturer", nil, "MAC manufacturer", 5],
  ["host_description", nil, "Description", nil, "Description", 6]
]

node_network_label_radio_actions = [
  ["network_name", nil, "Name", nil, "Name", 0],
  ["network_dns_domain", nil, "DNS Domain", nil, "DNS Domain", 1],
  ["network_netbios_domain", nil, "Netbios Domain", nil, "Netbios Domain", 2],
  ["network_ip", nil, "IP", nil, "IP", 3],
  ["network_osl", nil, "OS", nil, "OS", 4],
  ["network_description", nil, "Description", nil, "Description", 5]
]

node_host_icon_radio_actions = [
  ["host_osi", nil, "OS", nil, "OS", 0],
  ["host_type", nil, "Type", nil, "Type", 1]
]
node_network_icon_radio_actions=[
  ["network_osi", nil, "OS", nil, "OS", 0],
  ["network_type", nil, "Type", nil, "Type", 1]
]
  @ag=actiongroup = Gtk::ActionGroup.new("Actions")
  actiongroup.add_actions(actions)

  map_display=0
  map_window_radio_actions.each do |tab|
	if $config.map_display_view == tab[0]
		map_display=tab[5]
	end
  end
  actiongroup.add_radio_actions(map_window_radio_actions, map_display, proc_map_window )

  label_view_pos=0
  node_host_label_radio_actions.each do |tab|
		if ("host_#{$config.host_label_view}" == tab[0]) || ("host_#{$config.host_label_view}l" == tab[0])
			break
		end
		label_view_pos+=1
  end
  actiongroup.add_radio_actions(node_host_label_radio_actions, label_view_pos, proc_label )

  label_view_pos=0
  node_network_label_radio_actions.each do |tab|
		if ("network_#{$config.network_label_view}" == tab[0]) || ("network_#{$config.network_label_view}l" == tab[0])
			break
		end
		label_view_pos+=1
  end
  actiongroup.add_radio_actions(node_network_label_radio_actions, label_view_pos, proc_label )
  
  icon_view_pos=0
  node_host_icon_radio_actions.each do |tab|
		if ("host_#{$config.host_icon_view}" == tab[0]) || ("host_#{$config.host_icon_view}i" == tab[0])
			break
		end
		icon_view_pos+=1
  end
  actiongroup.add_radio_actions(node_host_icon_radio_actions, icon_view_pos, proc_icon )

  icon_view_pos=0
  node_network_icon_radio_actions.each do |tab|
		if ("network_#{$config.network_icon_view}" == tab[0]) || ("network_#{$config.network_icon_view}i" == tab[0])
			break
		end
		icon_view_pos+=1
  end
  actiongroup.add_radio_actions(node_network_icon_radio_actions, icon_view_pos, proc_icon )

  uimanager = Gtk::UIManager.new
  uimanager.insert_action_group(actiongroup, 0)
  add_accel_group(uimanager.accel_group)
  uimanager.add_ui(main_menu)
  @main_bar=uimanager.get_widget("/MainBar")
  #we set height size
  @main_bar.height_request=30

  $canvas=CanvasMap.new
  $canvas_root=$canvas.get_root()

  @main_vbox = Gtk::VBox.new()

  @main_vbox.pack_start(@main_bar, false)
  @main_vbox.pack_start($canvas, true, true) 

    @main_vbox.signal_connect('size-allocate') { |w,e|
		set_map_display_view_user_defined()
		height=e.height
		if !$canvas.fullscreen?()
			height -= @main_bar.height_request
		else
			#we need to store $win size!
			$root_width=$win.window.geometry[2]
			$root_height=$win.window.geometry[3]
		end
		$canvas.set_size(e.width, height)
   	false
    }
 
  add(@main_vbox)
  show_all()
  $canvas.grab_focus()
  #on startup we hide some menu entries
  hide_menu_entry()

   end

  private
	def create_plugins_list (plist)
		launch_plugin = Proc.new do |action, plugin|		
		cmd=plugin.name
		cmd="#{cmd[0,1].capitalize()}#{cmd[1,cmd.size - 1]}"
        	 #use thread to prevent crash from bogus name with file & class
         	 Thread.start {
		 begin
         	    Object.const_get(cmd).new()
		 rescue Exception => msg
			$log.error("running plugin #{cmd}: #{msg}")
		 end
         	 }
		end
	  $plugin_name_list.each {|plugin_name|
		  plist.push(["#{plugin_name}", nil, "#{plugin_name}", nil, "", launch_plugin ])
	  }
  end
 
#####begin host node icon#####################
private
  def host_icon()
	if get_map() != nil
	 $network[get_map()].host.each_value {|n|
		   n.reload
	 }
	end
  end
#####end host node icon#####################

#####begin network node icon#####################
private
  def network_icon()
	if get_map() != nil
    $network[get_map()].network.each_value {|n|
		   n.reload()
	 }
	else
		$network[ROOTMAPADDR].reload()
	end
  end
#####end network node icon#####################

#####begin host node label#####################
  private
  def host_label()
	if get_map() != nil
	 $network[get_map()].host.each_value {|n|
		   n.change_label($config.host_label_view)
	 }
	end
  end
 
#####end host node label#####################

#####begin network node label#####################
  private
  def network_label()
	if get_map() != ROOTMAPADDR
	 $network[get_map()].network.each_value {|n|
		   n.change_label($config.network_label_view)
	 }
	else
		   $network[ROOTMAPADDR].change_label($config.network_label_view)
	end
  end
 
#####end network node label#####################
  
####################################################################################################
#
# Modify node position to keep relative position from the window
#
public
def proportional_node_position(wold, hold,w,h)

	tmp_table= [$host, $network]
	tmp_table.each {|hsh|
	  hsh.each_key {|ip|
	    xp=hsh[ip].x / wold.to_f
	    yp=hsh[ip].y / hold.to_f
	    
	    x = (xp*w).to_i
	    y = (yp*h).to_i
	    hsh[ip].node_view.hide_link()
	    hsh[ip].node_view.move(x-hsh[ip].x,y-hsh[ip].y)
	    hsh[ip].node_view.show_link()
	  }
	}
end

private
def map_window_activ_full 
  if $win !=nil
    w=Gdk::screen_width
    h=Gdk::screen_height-30
	root_width=$win.window.geometry[2]
	root_height=$win.window.geometry[3]
    $win.window.resize(w,h)
    proportional_node_position(root_width,root_height,w,h)
  end
end

private
def map_window_activ_half
  if $win !=nil
    w=Gdk::screen_width*2/3
    h=Gdk::screen_height*2/3
  	 root_width=$win.window.geometry[2]
  	 root_height=$win.window.geometry[3]
    $win.window.resize(w,h)
    proportional_node_position(root_width,root_height,w,h)
  end
end

private
def map_window_activ_quart
  if $win !=nil
    w=Gdk::screen_width/2
    h=Gdk::screen_height/2
    root_width=$win.window.geometry[2]
    root_height=$win.window.geometry[3]
    $win.window.resize(w,h)
    proportional_node_position(root_width,root_height,w,h)
  end
end

###################################################################################################
#
#	popup to confirm init db
#
def confirm_initdb_window()
   	dialog = Gtk::MessageDialog.new($win, Gtk::Dialog::DESTROY_WITH_PARENT,
                           	  Gtk::MessageDialog::QUESTION,
                           	  Gtk::MessageDialog::BUTTONS_YES_NO,
                           	  "Do you really want to reset your node database ?")
		dialog.run do |r|
			dialog.destroy
			if r == Gtk::Dialog::RESPONSE_NO
				return false
			else
				return true
			end	
		end
end

private
def new_map()
  if confirm_initdb_window()
    thread_stopping()
    save()
    $event_win.clean
    $event_win.filter_by_node()
    init_map()
    thread_starting()
  end
end

public
def window_close
  destroy
end

private
def create_config_option
  $config.show()
end

private
def create_help
  help_window()
end

private
def open_file()

  fs=Gtk::FileChooserDialog.new("Open XML backup file",
  self,
  Gtk::FileChooser::ACTION_OPEN,
  nil,
  [Gtk::Stock::OPEN, Gtk::Dialog::RESPONSE_ACCEPT],
  [Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL]
  )
  xml_filter=Gtk::FileFilter.new
  xml_filter.set_name("XML files")
  xml_filter.add_pattern("*.xml")
  fs.add_filter(xml_filter)
  if fs.run == Gtk::Dialog::RESPONSE_ACCEPT
    init_map()
    $win.set_title("Gnms -> Load #{fs.filename}")
    read_xml(fs.filename)
    interfaces_table = local_interface()
    if interfaces_table.size > 0
      ip_of_first_interface = interfaces_table[0][0]
      $event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", $host[ip_of_first_interface], "Load #{fs.filename}")
    else
      $event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", $host["127.0.0.1"], "Load #{fs.filename}")
    end
    $event_win.update_statusbar()
  end
  fs.destroy
end

private
def save_file()
  save_to_filename=nil
  fs=Gtk::FileChooserDialog.new("Save as File",
  self,
  Gtk::FileChooser::ACTION_SAVE,
  nil,
  [Gtk::Stock::SAVE, Gtk::Dialog::RESPONSE_ACCEPT],
  [Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL]
  )
  xml_filter=Gtk::FileFilter.new
  xml_filter.set_name("XML files")
  xml_filter.add_pattern("*.xml")
  fs.add_filter(xml_filter)
  if fs.run == Gtk::Dialog::RESPONSE_ACCEPT
    save_to_filename=fs.filename
  end
  fs.destroy
  return save_to_filename
end

private
def save_as
  save_to_filename=save_file()
  if save_to_filename != nil
    write_xml(save_to_filename)
  end
end

#
# save all nodes info in db but do not quit the application
#
private
def save()
      save_all_in_db()
end

def snapshot()
  def snapshot_file()
    i=1
    while (FileTest.exist?("#{SNAPSHOT_DIR}/snapshot-#{i}.png"))
      i+=1
    end
    return "#{SNAPSHOT_DIR}/snapshot-#{i}.png"
  end
  win=Gtk::Window.new
  win.set_transient_for($win)
  win.set_title "Take a snapshot"
  ok_button=Gtk::Button.new("Snap it as #{snapshot_file()}")
  win.add ok_button
  win.show_all
  win.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      win.destroy
    end
  }

  ok_button.signal_connect("clicked") {
    x, y, width, height, depth = $canvas.window.geometry()
    pixbuf = Gdk::Pixbuf.from_drawable(Gdk::Colormap.system,
    $canvas.window, 0, 0,
    width, height)
    begin
      pixbuf.save(snapshot_file(), "png") unless pixbuf == nil
    rescue
      $log.error("Can't save snapshot image to #{snapshot_file()}")
    end
    ok_button.set_label("Snap it as #{snapshot_file()}")
  }
end

def init_map()
  set_map()
  $network.each_key {|ip|
    if ip != ROOTMAPADDR
      $network[ip].delete
    end
  }
  $host.each_key {|ip|
    $host[ip].delete
  }
end
end
