#
# this file contain color variable and function both for node class and other files
#


#
# load image, return a pixmap
#
def load_image (file, keepisgeometry="")
  if file[0,1] == '/'
    rfile = file
  else
    rfile = "#{PIXMAP_PATH}/#{file}"
  end
  if FileTest.exist? rfile
    im = Gtk::Image.new(rfile)
  else
    print "#{rfile} doesnt exist!","\n"
    load_image "type/pc.gif"
  end
end


def find_extension (file)
if FileTest.exist?("#{PIXMAP_PATH}/#{file}.png")
    return "#{file}.png"
  elsif FileTest.exist?("#{PIXMAP_PATH}/#{file}.gif")
      return "#{file}.gif"
    elsif FileTest.exist?("#{PIXMAP_PATH}/#{file}.jpg")
        return "#{file}.jpg"
      elsif FileTest.exist?("#{PIXMAP_PATH}/#{file}.xpm")
          return "#{file}.xpm"
	else
          return "null"
        end
end

#
#	convert rgb to hex color str
#
def rgb_to_hex_color(rgb)
	if rgb.class == Gdk::Color
		r,g,b=rgb.to_a()
		r=(r-1)/256 unless r==0
		g=(g-1)/256 unless g==0
		b=(b-1)/256 unless b==0
		hex_result=""
		[r,g,b].each do |comp|
				hex=sprintf("%x",comp)
				if hex == '0'
					hex_result+="00"
				else
					hex_result+=hex
				end
		end
		return hex_result
	end
end

#
#	convert hexa value to a rgb Gdk::Color
#
def hexa_to_rgb_color(rgb)
	hexa_str=sprintf("%8x",rgb)
	tab=hexa_str.match(/(.{2})(.{2})(.{2}).{2}/)
	r=tab[1]
	g=tab[2]
	b=tab[3]
	
	if r== "  "
		r="00"
	elsif b=="  "
		b="00"
	end

	rd=sprintf("%d","0x#{r}")
	gd=sprintf("%d","0x#{g}")
	bd=sprintf("%d","0x#{b}")

	return Gdk::Color.new(rd.to_i()*256,gd.to_i()*256,bd.to_i()*256)
end

def hexa_to_rgb_color_str(rgb)

  hexa_str=sprintf("%06x",rgb)
  hexa_str=hexa_str.chop()
  hexa_str=hexa_str.chop()
  if hexa_str.length < 6
    hexa_str="00"+hexa_str
  end
  return "##{hexa_str}"
end

    #color
    
    $red 	= hexa_to_rgb_color($status_color[$status.index("CRITICAL")])
    $orange =  hexa_to_rgb_color($status_color[$status.index("MAJOR")])
    $yellow = hexa_to_rgb_color($status_color[$status.index("WARNING")])
    $blue	= hexa_to_rgb_color($status_color[$status.index("MINOR")])
    $green	= hexa_to_rgb_color($status_color[$status.index("NORMAL")])
    $grey 	= Gdk::Color.new(49151, 49151, 49151)
    $purple = Gdk::Color.new(37888, 26880, 58880)
    #for tooltips background
    $light_yellow = Gdk::Color.new(64515, 62985, 50745)

    #color style

    $red_style = Gtk::Style.new
    $orange_style = Gtk::Style.new
    $green_style = Gtk::Style.new
    $grey_style = Gtk::Style.new
    $yellow_style = Gtk::Style.new
    $blue_style = Gtk::Style.new

    $red_style.set_text(Gtk::STATE_NORMAL, $red.red, $red.green, $red.blue)
    $red_style.set_text(Gtk::STATE_ACTIVE, $red.red, $red.green, $red.blue)
    $red_style.set_bg(Gtk::STATE_NORMAL, $orange.red, $orange.green, $orange.blue)
    $red_style.set_bg(Gtk::STATE_ACTIVE, $orange.red, $orange.green, $orange.blue)
    $red_style.set_bg(Gtk::STATE_PRELIGHT, $orange.red, $orange.green, $orange.blue)

    $orange_style.set_text(Gtk::STATE_NORMAL, $orange.red, $orange.green, $orange.blue)
    $orange_style.set_text(Gtk::STATE_ACTIVE, $orange.red, $orange.green, $orange.blue)
    $orange_style.set_bg(Gtk::STATE_NORMAL, $orange.red, $orange.green, $orange.blue)
    $orange_style.set_bg(Gtk::STATE_ACTIVE, $orange.red, $orange.green, $orange.blue)
    $orange_style.set_bg(Gtk::STATE_PRELIGHT, $orange.red, $orange.green, $orange.blue)

    $yellow_style.set_text(Gtk::STATE_NORMAL, $yellow.red, $yellow.green, $yellow.blue)
    $yellow_style.set_text(Gtk::STATE_ACTIVE, $yellow.red, $yellow.green, $yellow.blue)
    $yellow_style.set_bg(Gtk::STATE_NORMAL, $yellow.red, $yellow.green, $yellow.blue)
    $yellow_style.set_bg(Gtk::STATE_ACTIVE, $yellow.red, $yellow.green, $yellow.blue)
    $yellow_style.set_bg(Gtk::STATE_PRELIGHT, $yellow.red, $yellow.green, $yellow.blue)

    $blue_style.set_text(Gtk::STATE_NORMAL, $blue.red, $blue.green, $blue.blue)
    $blue_style.set_text(Gtk::STATE_ACTIVE, $blue.red, $blue.green, $blue.blue)
    $blue_style.set_bg(Gtk::STATE_NORMAL, $blue.red, $blue.green, $blue.blue)
    $blue_style.set_bg(Gtk::STATE_ACTIVE, $blue.red, $blue.green, $blue.blue)
    $blue_style.set_bg(Gtk::STATE_PRELIGHT, $blue.red, $blue.green, $blue.blue)

    $green_style.set_bg(Gtk::STATE_NORMAL, $green.red, $green.green, $green.blue)
    $green_style.set_bg(Gtk::STATE_ACTIVE, $green.red, $green.green, $green.blue)
    $green_style.set_bg(Gtk::STATE_PRELIGHT, $green.red, $green.green, $green.blue)

    $grey_style.set_bg(Gtk::STATE_NORMAL, 49151, 49151, 49151)
    $grey_style.set_bg(Gtk::STATE_ACTIVE, 49151, 49151, 49151)
    $grey_style.set_bg(Gtk::STATE_PRELIGHT, 49151, 49151, 49151)
