#
# module to find host
#

require "#{GNMSLIB}"+'/gui/widgets.rb'

def findnodewin()

win_title="Find node"

node_type=["Host", "Network", "Any"]
search_host=["IP", "Status", "Mac", "Dns name", "Netbios name", "Description", "Type","OS" ]
search_network=["IP", "Status", "Name", "Dns domain", "Netbios domain",  "Description", "Type","OS" ]
search_any=["IP", "Status","Dns name","Netbios name", "Description", "Type","OS"]

win = Gtk::Window.new
win.set_transient_for($win)
win.set_title win_title
win.set_size_request(600,415)

vbox_root=Gtk::VBox.new
vbox_root.show
win.add vbox_root


frame = Gtk::Frame::new
frame.border_width=10
frame.show
vbox_root.add frame

vbox_frame=Gtk::VBox.new
vbox_frame.show
frame.add vbox_frame

hhbox_root=Gtk::HBox.new
hhbox_root.set_size_request(-1,10)
hhbox_root.show
hhbox = Gtk::HBox.new
hhbox.show
hhbox_root.add hhbox

vbox_frame.add hhbox_root

node_type_combo = Gtk::ComboBox.new
node_type_combo.set_size_request(60,-1)
node_type.each do |val|
	node_type_combo.append_text(val)
end
node_type_combo.set_active(0)
node_type_combo.show
hhbox.add node_type_combo

type_choice = Gtk::ComboBox.new()
type_choice.set_size_request(100,-1)
search_host.each do |shost|
	type_choice.append_text(shost)
end
type_choice.set_active(0)
type_choice.show
hhbox.add type_choice

entry_glb=Gtk::Entry.new
interfaces_table = local_interface()
if interfaces_table.size > 0
   ip_of_first_interface = interfaces_table[0][0]
   entry_glb.set_text ip_of_first_interface
end
entry_glb.show
hhbox.add entry_glb

vvbox=Gtk::VButtonBox.new
vvbox.show
hhbox_root.add vvbox
button_find=Gtk::Button.new(Gtk::Stock::FIND)
button_find.set_flags(Gtk::Widget::CAN_DEFAULT)
button_find.show
vvbox.add button_find

entry_glb.signal_connect("key_press_event") {|w,e|
  if e.keyval == Gdk::Keyval::GDK_Return
    button_find.clicked
  end
}

clist = Gtk::CList::new(search_host)
clist.show
clist.set_size_request 500,280
scroll = Gtk::ScrolledWindow.new(nil, nil)
scroll.border_width=2
scroll.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)  
vbox_frame.pack_start(scroll, true, true, 0)
scroll.show
scroll.add(clist)


bbox =Gtk::HBox::new(FALSE, 10)
bbox.border_width=10
bbox.show

button_clear=Gtk::Button.new(Gtk::Stock::CLEAR)
button_clear.show
button_close=Gtk::Button.new(Gtk::Stock::CLOSE)
button_close.show

button_clear.set_flags(Gtk::Widget::CAN_DEFAULT)
bbox.pack_start(button_clear, TRUE, TRUE, 0)
button_close.set_flags(Gtk::Widget::CAN_DEFAULT)
bbox.pack_start(button_close, TRUE, TRUE, 0)

separator = Gtk::HSeparator::new()
separator.show
vbox_root.pack_start(separator, FALSE, TRUE, 0)
vbox_root.pack_start(bbox, FALSE, TRUE, 0)


clist.signal_connect("cursor-changed") { |s, event|
	iter = s.selection.selected
	ip=s.model.get_value(iter,1)
	if $network.has_key?(ip)
		set_map($network[ip].map)
		$network[ip].node_view.select()
	else
		if $host[ip] != nil
			set_map($host[ip].map)
			$host[ip].node_view.select()
		end
	end
}
win.show

button_close.signal_connect("clicked") {
  win.destroy
}

button_clear.signal_connect("clicked") {
	clist.clear
	win.set_title win_title
}

button_find.signal_connect("clicked") {
  clist.clear
  nb_node_find=0

  node_list=nil
  type=node_type_combo.active_text
	if type=="Network"
		node_list=$network
	elsif type=="Host"
		node_list=$host
	else
	#any type
		node_list=$host.merge($network)
	end

  case type_choice.active_text
  when "IP" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if ip==""
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
				nb_node_find+=1
			end
		elsif ip.index(entry_glb.text) != nil
			if type == "Any"
				array_without_mac=node_list[ip].to_t
				array_without_mac.delete_at(2)
				clist.append(array_without_mac)
			else
				clist.append(node_list[ip].to_t)
			end
			nb_node_find+=1
      end
    }
  when "Mac" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if (node_list[ip].mac!=nil) && (node_list[ip].mac==Node::NOARP_PROPERTY)
				clist.append(node_list[ip].to_t)
				nb_node_find+=1
			end
		elsif (node_list[ip].mac!=nil) && (node_list[ip].mac.index(entry_glb.text.upcase)!=nil)
			clist.append(node_list[ip].to_t)
			nb_node_find+=1
      end
    }
  when "Name" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if  node_list[ip].name==Node::NONAME_PROPERTY
				clist.append(node_list[ip].to_t)
				nb_node_find+=1
			end
		elsif node_list[ip].name.index(entry_glb.text) != nil
			clist.append(node_list[ip].to_t)
			nb_node_find+=1
      end
    }
  when "Dns name" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if node_list[ip].dns_name==Node::NONAME_PROPERTY
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
				nb_node_find+=1
			end
		elsif node_list[ip].dns_name.index(entry_glb.text) != nil
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
			nb_node_find+=1
      end
    }
  when "Dns domain" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if  node_list[ip].dns_domain==Node::NONAME_PROPERTY
				clist.append(node_list[ip].to_t)
				nb_node_find+=1
			end
		elsif node_list[ip].dns_domain.index(entry_glb.text) != nil
			clist.append(node_list[ip].to_t)
			nb_node_find+=1
      end
    }
  when "Netbios name" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if  node_list[ip].netbios_name==Node::NONAME_PROPERTY
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
				nb_node_find+=1
			end
		elsif node_list[ip].netbios_name.index(entry_glb.text) != nil
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
			nb_node_find+=1
      end
    }
  when "Netbios domain" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if  node_list[ip].netbios_domain==Node::NONAME_PROPERTY
				clist.append(node_list[ip].to_t)
				nb_node_find+=1
			end
		elsif node_list[ip].netbios_domain.index(entry_glb.text) != nil
			clist.append(node_list[ip].to_t)
			nb_node_find+=1
      end
    }
  when "Status" then
    node_list.each_key {|ip|
      if $status[$status_value.index(node_list[ip].status)] == entry_glb.active_text
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
			nb_node_find+=1
      end
    }
  when "Description" then
    node_list.each_key {|ip|
		if entry_glb.text==""
			if  node_list[ip].description==Node::NODESCR_PROPERTY
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
				nb_node_find+=1
			end
		elsif node_list[ip].description.index(entry_glb.text) != nil
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
			nb_node_find+=1
      end
    }
  when "Type" then
    node_list.each_key {|ip|
      if node_list[ip].type == entry_glb.active_text
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
			nb_node_find+=1
      end
    }
  when "OS" then
    node_list.each_key {|ip|
      if node_list[ip].os == entry_glb.active_text
				if type == "Any"
					#remove MAC addr from host or name from network result array
					array_without_mac=node_list[ip].to_t
					array_without_mac.delete_at(2)
					clist.append(array_without_mac)
				else
					clist.append(node_list[ip].to_t)
				end
			nb_node_find+=1
      end
    }
	end

    win.set_title(win_title+" - #{nb_node_find} result(s)")

}

win.signal_connect("key_press_event") {|w,e|
  if e.keyval == Gdk::Keyval::GDK_Escape
    win.destroy
  end
}

node_type_combo.signal_connect("changed") {|entry|
	case entry.active_text
	when "Host" then
		search_network.each do |sh|
			type_choice.remove_text(0)
		end
		search_host.each do |sh|
			type_choice.append_text(sh)
		end
		type_choice.set_active(0)
		clist.changed_all_column_name(search_host)
	when "Network" then
		search_host.each do |sh|
			type_choice.remove_text(0)
		end

		search_network.each do |sn|
			type_choice.append_text(sn)
		end
		type_choice.set_active(0)
		clist.changed_all_column_name(search_network)
	else
		#host & network have same number of entry in array type
		search_host.each do |sh|
			type_choice.remove_text(0)
		end

		search_any.each do |sn|
			type_choice.append_text(sn)
		end
		type_choice.set_active(0)
		clist.changed_all_column_name(search_any)
	end
	clist.clear
	win.set_title win_title
}

type_choice.signal_connect("changed") {|cbox|
  case cbox.active_text
  when "Type" then
    entry_glb.hide
    entry_glb.destroy
    entry_glb=Gtk::ComboBox.new
	 $type.each do |t|
		entry_glb.append_text(t)
	 end
	 entry_glb.set_active(0)
    entry_glb.show
    hhbox.add entry_glb
  when "OS" then
    entry_glb.hide
    entry_glb.destroy
    entry_glb=Gtk::ComboBox.new
	 $os.each do |os|
		entry_glb.append_text(os)
	 end
	 entry_glb.set_active(0)
    entry_glb.show
    hhbox.add entry_glb
  when "Status" then
    entry_glb.hide
    entry_glb.destroy
    entry_glb=Gtk::ComboBox.new
	 $status.each do |st|
		entry_glb.append_text(st)
	 end
	 entry_glb.set_active(0)
    entry_glb.show
    hhbox.add entry_glb
   else
      entry_glb.hide
      entry_glb.destroy
      entry_glb=Gtk::Entry.new
      entry_glb.show
      hhbox.add entry_glb
  end
}
end
