require "#{GNMSLIB}"+'/cmd_parse'

#
# window to get info from ip/mask
#
def netmask_calculator

    if $win == nil
  	    return
    end

    ipcalc=Gtk::Window.new

    ipcalc.set_title("IP calculator")
    ipcalc.set_size_request(340, 340)
    ipcalc.set_modal(true)

    ipcalc.signal_connect("key_press_event") {|w,e|
      if e.keyval == Gdk::Keyval::GDK_Escape
        ipcalc.destroy
      end
    }

    vbox = Gtk::VBox.new
    vbox.show
    ipcalc.add vbox

	 frame=Gtk::Frame.new
	 frame.border_width=10
	 frame.show
	 vbox.add frame

    table = Gtk::Table.new(3,2,false)
    table.show

    label_ip = Gtk::Label.new "IP"
    label_ip.show
    entry_ip = Gtk::Entry.new
    entry_ip.set_text "0.0.0.0"
    entry_ip.show
    eval_button = Gtk::Button.new(Gtk::Stock::EXECUTE)
    eval_button.show

    hbox = Gtk::HBox.new
    hbox.show

	 hbox.add entry_ip
	 hbox.add eval_button

    table.attach(label_ip,0,1,0,1)
    table.attach(hbox,1,2,0,1)

    label_netmask = Gtk::Label.new "Netmask"
    label_netmask.show
	
    hbox = Gtk::HBox.new
    hbox.show
    entry_netmask = Gtk::Entry.new
    entry_netmask.set_text DEFAULT_CLASS_C_NETMASK
    entry_netmask.set_editable false
    entry_netmask.show
  
    adj = Gtk::Adjustment::new(0, 1.0, 32.0, 1.0, 5.0, 0.0)
    compressnetmask = Gtk::SpinButton::new(adj, 0, 0)
    compressnetmask.set_wrap(true)
    compressnetmask.set_editable false
    compressnetmask.set_value 24.0

    compressnetmask.show
    hbox.add entry_netmask
    hbox.add compressnetmask
    table.attach(label_netmask,0,1,1,2)
    table.attach(hbox,1,2,1,2)
    text = Gtk::TextView.new
    text.cursor_visible=false
    text.set_size_request(150,200)
    text.set_editable(false)
    text.show
    
    bbox = Gtk::HButtonBox.new
    bbox.set_layout_style(Gtk::ButtonBox::SPREAD)
    bbox.set_size_request(50,30)
    bbox.show

    compressnetmask.signal_connect("value-changed") {
      entry_netmask.set_text bit2netmask(compressnetmask.value_as_int)
    }

    eval_button.signal_connect("clicked") {
    if isValidIPv4(entry_ip.text)
   	text.buffer.place_cursor(text.buffer.start_iter)
   	if compressnetmask.value == "0"
        text.buffer.insert_at_cursor(IPCalc::ipcalc_detail(entry_ip.text))
   	else
        text.buffer.insert_at_cursor(IPCalc::ipcalc_detail("#{entry_ip.text}/#{compressnetmask.text}"))
   	end
    else 
    	errorEntry(ipcalc, entry_ip.text)
    end
    }
    entry_ip.signal_connect("key_press_event") {|w,e|
      if e.keyval == 65293 || e.keyval == 65421 #Enter key
        eval_button.clicked
      end
    }
    entry_netmask.signal_connect("key_press_event") {|w,e|
      if e.keyval == 65293 || e.keyval == 65421 #Enter key
        eval_button.clicked
      end
    }
    compressnetmask.signal_connect("key_press_event") {|w,e|
      if e.keyval == 65293 || e.keyval == 65421 #Enter key
        eval_button.clicked
      end
    }
    
    
  clear_button = Gtk::Button.new(Gtk::Stock::CLEAR)
  clear_button.show
  clear_button.signal_connect("clicked") {
	  text.buffer.delete(text.buffer.start_iter,text.buffer.end_iter)
  }

  cancel_button = Gtk::Button.new(Gtk::Stock::CLOSE)
  cancel_button.show
  cancel_button.signal_connect("clicked") {
  	  ipcalc.destroy 
  }

  bbox.add clear_button
  bbox.add cancel_button
  frame.add table
	
  scrolled_window = Gtk::ScrolledWindow.new(nil, nil)
  scrolled_window.border_width=2
  scrolled_window.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC)  

  vbox.add scrolled_window
  scrolled_window.show
  scrolled_window.add(text)

  separator = Gtk::HSeparator::new()
  separator.show
  vbox.add separator
  vbox.add bbox
  ipcalc.show
end
