class JMXRefWindow

	def clear_ls()
		@jmx_ref_ls.clear()
	end
	#populate listview with saved values
	def populate_ls()
   	$jmx_refs.each_key do |name|
		  iter = @jmx_ref_ls.append
		  iter[0] = name
		  iter[1] = $jmx_refs[name].description
		end
	end

	def initialize()
		#save jmxref hash
		@jmxrefs_backup=$jmx_refs.dup
		@window=Gtk::Window.new
	   	@window.set_title("JMX Ref configuration")
   		@window.set_size_request(300, 200)

	      @window.signal_connect("key_press_event") {|w,e|
        	if e.keyval == Gdk::Keyval::GDK_Escape
			  @window.destroy
	        end
   		}

		frame = Gtk::Frame::new
		frame.border_width=5
		frame.show
		vbox_root=Gtk::VBox::new
		vbox_root.show
		@window.add vbox_root
		vbox_root.add frame

		vbox = Gtk::VBox.new(false,0)
		vbox.show
		frame.add vbox

	   @jmx_ref_ls = Gtk::ListStore.new(String, String)
  	   @jmx_ref_view = Gtk::TreeView.new(@jmx_ref_ls)
		@jmx_ref_view.show
 		column1 = Gtk::TreeViewColumn.new("Name",
					Gtk::CellRendererText.new, {:text => 0})
  		column1.set_sort_column_id(0)
  		column2 = Gtk::TreeViewColumn.new("Description",
					Gtk::CellRendererText.new, {:text => 1})
  		column2.set_sort_column_id(1)

  		@jmx_ref_view.append_column(column1)
  		@jmx_ref_view.append_column(column2)
  		
		scroll = Gtk::ScrolledWindow.new(nil, nil)
		scroll.border_width=2
		scroll.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC)  
		scroll.add @jmx_ref_view
		scroll.show

		# Create a menu
		menu = Gtk::Menu.new

		item_add = Gtk::ImageMenuItem.new("Add jmx Ref")
 		image_item_add = Gtk::Image.new() 
 		image_item_add.set_stock(Gtk::Stock::ADD) 
		item_add.set_image(image_item_add)
		item_add.signal_connect("activate") { add_gui_jmx_ref() }
		menu.append(item_add)
		item_del = Gtk::ImageMenuItem.new("Delete selected jmx Ref")
 		image_item_del = Gtk::Image.new() 
 		image_item_del.set_stock(Gtk::Stock::REMOVE) 
		item_del.set_image(image_item_del)
		item_del.signal_connect("activate") {
			if @jmx_ref_view.selection.selected!=nil
				if JMXRef::del_jmx_ref(@jmx_ref_view.selection.selected[0])
					@jmx_ref_view.model.remove(@jmx_ref_view.selection.selected)
				else
   				dialog = Gtk::MessageDialog.new(@window, Gtk::Dialog::DESTROY_WITH_PARENT,
                             Gtk::MessageDialog::ERROR,
                             Gtk::MessageDialog::BUTTONS_OK,
                             "You can't delete! jmx Ref in use")
					dialog.run
					dialog.destroy
				end
			end
		}
		menu.append(item_del)
		item_edit = Gtk::ImageMenuItem.new("Edit jmx Ref")
 		image_item_edit = Gtk::Image.new() 
 		image_item_edit.set_stock(Gtk::Stock::EDIT) 
		item_edit.set_image(image_item_edit)
		item_edit.signal_connect("activate") { 
			if @jmx_ref_view.selection.selected != nil
				edit_jmx_ref(@jmx_ref_view.selection.selected[0]) 
			end
		}
		menu.append(item_edit)

		@jmx_ref_view.signal_connect("button_press_event") do |widget, event|
	  		if event.kind_of? Gdk::EventButton and event.button == 3
				if @jmx_ref_view.selection.selected == nil
					item_del.set_sensitive(false)
					item_edit.set_sensitive(false)
				else
					item_del.set_sensitive(true)
					item_edit.set_sensitive(true)
				end
   		 	menu.popup(nil, nil, event.button, event.time)
			elsif (@jmx_ref_view.selection.selected != nil) && (event.event_type == Gdk::Event::BUTTON2_PRESS)
				edit_jmx_ref(@jmx_ref_view.selection.selected[0])	
	  		end
		end

		menu.show_all

		populate_ls()
		vbox.add(scroll)

		bbox = Gtk::HBox::new(FALSE, 10)
		bbox.border_width=10
		bbox.show

		ok_button = Gtk::Button.new(Gtk::Stock::OK)
		ok_button.show
		ok_button.signal_connect("clicked") {
			JMXRef::write_db_jmxref()
			@window.destroy
		}

		cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
		cancel_button.show
		cancel_button.signal_connect("clicked") {
		  $jmx_refs=@jmxrefs_backup
   	  @window.destroy
		}
		ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
		bbox.pack_start(ok_button, TRUE, TRUE, 0)
		cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
		bbox.pack_start(cancel_button, TRUE, TRUE, 0)

		separator = Gtk::HSeparator::new()
		separator.show
		vbox_root.pack_start(separator, FALSE, TRUE, 0)
		vbox_root.pack_start(bbox, FALSE, TRUE, 0)

		@window.show
   end

	def add_gui_jmx_ref()
		add_modify_jmx_ref(true)
	end

	def edit_jmx_ref(jmx_ref_name)
		add_modify_jmx_ref(false, jmx_ref_name)
	end

	def add_modify_jmx_ref(add_boolean, jmx_ref_name=nil)
		window=Gtk::Window.new
		window.set_modal(true)
		lbl="Edit jmx Ref"
		if add_boolean
			lbl="Add jmx Ref"
		end
		
   	window.set_title(lbl)
   	window.set_size_request(460, 200)

      window.signal_connect("key_press_event") {|w,e|
        if e.keyval == Gdk::Keyval::GDK_Escape
			  window.destroy
        end
   	}

		frame = Gtk::Frame::new
		frame.border_width=10
		frame.show
		vbox_root=Gtk::VBox::new
		vbox_root.show
		window.add vbox_root
		vbox_root.add frame

		vbox = Gtk::VBox.new
		vbox.show
		frame.add vbox

		table = Gtk::Table.new(4,2,false)
		table.show

		label_name = Gtk::Label.new "Name"
		label_name.show
		if add_boolean
			entry_name = Gtk::Entry.new			
		else
			entry_name = Gtk::Entry.new	
			entry_name.set_editable false
			entry_name.set_text(jmx_ref_name)
		end
		entry_name.show

		table.attach(label_name,0,1,0,1)
		table.attach(entry_name,1,2,0,1)

		entry_description = Gtk::Entry.new
		if !add_boolean
			entry_description.set_text($jmx_refs[entry_name.text()].description) unless entry_name.text() == ""
		end
		entry_description.show
		label_description = Gtk::Label.new "Description"
		label_description.show

		table.attach(label_description,0,1,1,2)
		table.attach(entry_description,1,2,1,2)

		entry_mbean = Gtk::Entry.new
		if !add_boolean
			entry_mbean.set_text($jmx_refs[entry_name.text()].mbean) unless entry_name.text() == ""
		end
		entry_mbean.show
		label_mbean = Gtk::Label.new "Object Name(s)"
		label_mbean.show

		table.attach(label_mbean,0,1,2,3)
		table.attach(entry_mbean,1,2,2,3)
		if !add_boolean
    		  entry_name.signal_connect("changed") {|e|
      	 	  	if e.text() != ""
				entry_description.set_text($jmx_refs[e.text()].description)
				entry_mbean.set_text($jmx_refs[e.text()].mbean)
				entry_attr.set_text($jmx_refs[e.text()].attribute)
			end
	    	  }
		end
		entry_attr = Gtk::Entry.new
		if !add_boolean
			entry_attr.set_text($jmx_refs[entry_name.text()].attribute) unless entry_name.text() == ""
		end
		entry_attr.show
		label_attr = Gtk::Label.new "Attribute Name(s)"
		label_attr.show

		table.attach(label_attr,0,1,3,4)
		table.attach(entry_attr,1,2,3,4)


		bbox =Gtk::HBox::new(FALSE, 10)
		bbox.border_width=10
		bbox.show

		ok_button = Gtk::Button.new(Gtk::Stock::OK)
		ok_button.show
		ok_button.signal_connect("clicked") {
			if entry_name.text == "" || entry_mbean.text == "" || entry_attr.text == ""
				if entry_name.text == ""
					entry_name.grab_focus
				elsif entry_mbean.text == ""
					entry_mbean.grab_focus
					else entry_attr.grab_focus
				end
			else
			if add_boolean
				#new entry!
				if $jmx_refs[entry_name.text()] == nil
					JMXRef::add_jmx_ref(entry_name.text(),entry_description.text(),entry_mbean.text(),entry_attr.text())
				   iter = @jmx_ref_ls.append
				   iter[0] = entry_name.text()
				   iter[1] = entry_description.text()
					window.destroy 
				else
   				dialog = Gtk::MessageDialog.new(window, Gtk::Dialog::DESTROY_WITH_PARENT,
                             Gtk::MessageDialog::ERROR,
                             Gtk::MessageDialog::BUTTONS_OK,
                             "jmx Ref '#{entry_name.text()}' already exists!")
					dialog.run
					dialog.destroy
				end
			else
				#modify existing entry
				$jmx_refs[entry_name.text()].description=entry_description.text()
				$jmx_refs[entry_name.text()].mbean=entry_mbean.text()
				$jmx_refs[entry_name.text()].attribute=entry_attr.text()
				@jmx_ref_ls.each do |model,path,iter|
					if iter[0] == entry_name.text()
						iter[1]=entry_description.text()
						break
					end
				end
				window.destroy 
			end
			end
		}

		cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
		cancel_button.show
		cancel_button.signal_connect("clicked") {
   	  window.destroy
		}

		ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
		bbox.pack_start(ok_button, TRUE, TRUE, 0)
		cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
		bbox.pack_start(cancel_button, TRUE, TRUE, 0)

		vbox.add(table)
		separator = Gtk::HSeparator::new()
		separator.show
		vbox_root.pack_start(separator, FALSE, TRUE, 0)
		vbox_root.pack_start(bbox, FALSE, TRUE, 0)
		window.show
	end
end
