  frame_account = Gtk::Frame::new
  frame_account.border_width=10
  frame_account.show

  vbox = Gtk::VBox::new
  vbox.show
  frame_account.add vbox

  account_ls = Gtk::ListStore.new(String, String, String)
  @account_view = Gtk::TreeView.new(account_ls)

  def cell_edited(cell, path_string, new_text, col, node)
	iter = @account_view.model.get_iter(path_string)
	#check if account id does not already exist for the host
	if (node.ip != ROOTMAPADDR) && (iter[0] != "snmp")	
	   #None is a special entry
	   if (col == 0) && ((node.account_exist?(new_text)) || (new_text.upcase == "NONE") || (new_text.upcase == ""))
		   return	
	   end
	   #we have to store the modified value
	   if col == 0
		   login, password = node.get_account_id(iter[0])
		   node.del_account(iter[0])		
		   node.add_account(new_text, login, password)
	   elsif col == 1
		   node.set_account_login(iter[0], new_text)
	   elsif col == 2
		   node.set_account_password(iter[0], new_text)
	   end
	   iter[col] = new_text
	else
		errorEntry(@window, "'snmp' account has to be configured in Option>Preference>SNMP tab")
	end
  end

  tr0=Gtk::CellRendererText.new
  tr0.editable=true
  tr0.mode=Gtk::CellRenderer::MODE_EDITABLE
  tr0.signal_connect("edited") { |renderer, iter, var|
	cell_edited(renderer, iter, var, 0, node) 
  }  
  column1 = Gtk::TreeViewColumn.new("ID Name", tr0, {:text => 0})
  column1.set_sort_column_id(0)
  
  tr1=Gtk::CellRendererText.new
  tr1.editable=true
  tr1.mode=Gtk::CellRenderer::MODE_EDITABLE
  tr1.signal_connect("edited") { |renderer, iter, var|
	cell_edited(renderer, iter, var, 1, node) 
  } 
  column2 = Gtk::TreeViewColumn.new("Login", tr1, {:text => 1})
  column2.set_sort_column_id(1)
  
  tr2=Gtk::CellRendererText.new
  tr2.editable=true
  tr2.mode=Gtk::CellRenderer::MODE_EDITABLE
  tr2.signal_connect("edited") { |renderer, iter, var|
	cell_edited(renderer, iter, var, 2, node) 
  }
  column3 = Gtk::TreeViewColumn.new("Password", tr2, {:text => 2})
  column3.set_sort_column_id(2)

  #by default we hide password column
  column3.set_visible(false)

  @account_view.append_column(column1)
  @account_view.append_column(column2)
  @account_view.append_column(column3)
  @account_view.show

  def insert_account_entry(node)
	if !node.account_exist?("default")
		iter=@account_view.model.append
		iter[0] = "default"
		iter[1] = "value1"
		iter[2] = "value2"
		node.add_account(iter[0], iter[1], iter[2])
	else
		errorEntry(@window, "'default' account already exists")
	end
  end

  def remove_selected_account_entry(node)
	if @account_view.selection.selected
		if (node.ip != ROOTMAPADDR) && (@account_view.model.get_value(@account_view.selection.selected,0)!= "snmp")
		    node.del_account(@account_view.model.get_value(@account_view.selection.selected,0))
		    @account_view.model.remove(@account_view.selection.selected)
		else
			errorEntry(@window, "'snmp' account can't be deleted")
		end
	end
  end

  @account_view.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Delete
	remove_selected_account_entry(node)
    elsif e.keyval == Gdk::Keyval::GDK_Insert
	insert_account_entry(node)
    end
    }
	
	#load existing entries
	nbaccounts=0
	node.get_all_account().each_pair {|id, table|	
		iter=@account_view.model.append
		iter[0] = id
		iter[1] = table[0]
		iter[2] = table[1]
		nbaccounts+=1
	}

	if nbaccounts == 0
	#load default entries if needed
	   for id in ["wmi","snmp","telnet", "ssh", "custom", "mysql", "oracle", "ipmi"]
		   if !node.account_exist_nr?(id)
			   #add a default one
			   iter=@account_view.model.append
			   iter[0] = id
			   if id == "snmp"
				   iter[1] = $config.read_community
				   iter[2] = $config.write_community
			   elsif id == "wmi"
				   iter[1] = "administrator"
				   iter[2] = "administrator"
			   elsif (id == "telnet") || (id == "ssh") || (id == "mysql") || (id == "ipmi")
				   iter[1] = "root"
				   iter[2] = "root"
			   else
				   iter[1] = "value1"
				   iter[2] = "value2"
			   end
			   node.add_account(id, iter[1], iter[2])
		   end
	   end
	end

	# Create a popup menu
	menu_account = Gtk::Menu.new

	item_add_account = Gtk::ImageMenuItem.new("Add account")
 	image_item_add_account = Gtk::Image.new()
 	image_item_add_account.set_stock(Gtk::Stock::ADD)
	item_add_account.set_image(image_item_add_account)
	item_add_account.signal_connect("activate") {
		insert_account_entry(node)
	}
	menu_account.append(item_add_account)

	item_del_account = Gtk::ImageMenuItem.new("Delete account")
 	image_item_del_account = Gtk::Image.new() 
 	image_item_del_account.set_stock(Gtk::Stock::REMOVE) 
	item_del_account.set_image(image_item_del_account)
	item_del_account.signal_connect("activate") {|renderer, iter, var|
		remove_selected_account_entry(node)	
	}
	menu_account.append(item_del_account)

	item_switch_password = Gtk::ImageMenuItem.new("Show password")
 	image_item_switch_password = Gtk::Image.new() 
 	image_item_switch_password.set_stock(Gtk::Stock::DIALOG_WARNING) 
	item_switch_password.set_image(image_item_switch_password)
	item_switch_password.signal_connect("activate") {|renderer, iter, var|
		if @account_view.get_column(2).visible?
			item_switch_password.label="Show password"
		else
			item_switch_password.label="Hide password"
		end
		@account_view.get_column(2).visible=!@account_view.get_column(2).visible?
	}
	menu_account.append(item_switch_password)

	menu_account.show_all

	@account_view.signal_connect("button_press_event") do |widget, event|
		if event.kind_of? Gdk::EventButton and event.button == 3
			menu_account.popup(nil, nil, event.button, event.time)
		end
	end

	hbox = Gtk::HBox.new(FALSE, 1)
	hbox.add Gtk::Image.new(Gtk::Stock::EDIT, Gtk::IconSize::MENU)
	hbox.add Gtk::Label::new("Account")
	hbox.show_all

  	scrollhbox = Gtk::HBox::new
  	scrollhbox.show
  	scrollhbox.add(@account_view)
  
	scrolled = Gtk::ScrolledWindow.new(nil, nil)
	scrolled.border_width=0
	scrolled.set_policy(Gtk::POLICY_NEVER,Gtk::POLICY_AUTOMATIC)
	scrolled.add_with_viewport(scrollhbox) 
	scrolled.show

	vbox.add(scrolled)
	notebook.append_page frame_account, hbox
