require 'net/http'

#
# get changelog from version arg
#
def get_changelog(version)
  changelog_text=""
  #changelog file name is changelog-last_version_file_name
  changelog_base_name="changelog-"

  begin
  Net::HTTP.start(GNMS_PROJECT_SERVER, 80) do |http|
	  response,=http.get('/'+GNMS_PROJECT_URL+'/'+changelog_base_name+version)
	  response.body.each do |str|
		changelog_text=changelog_text+"#{str}"
	  end
  end
  rescue
  end
  if changelog_text == ""
	return "No changelog available"
  else
	return changelog_text
  end
end

#
# check new update from the main home project url
#
#
def check_update_window
  last_version_file_name="lastversion"
  window = Gtk::Window.new
  window.set_size_request(500,250)
  window.set_title "Check update"
  window.set_transient_for($win)

  vbox = Gtk::VBox.new
  vbox.show
  window.add vbox

  begin
    Net::HTTP.version_1_1
  rescue
  end
  last_version=""
  text = Gtk::TextView.new
  combo_last_version = Gtk::ComboBox.new
  Thread.start {

  		begin
		Gtk.thread_protect do
			$win.hide_update_menu_entry()
		end
 		Net::HTTP.start(GNMS_PROJECT_SERVER, 80) do |http|
   	 	 response,=http.get('/'+GNMS_PROJECT_URL+'/'+last_version_file_name)
		 response.body.each do |str|
		  re=Regexp.new('^(\d+)\.(\d+)\.?(.+)?$')
		  str.scan(re) do |m1, m2, m3|
			  if (m1.to_i() > GNMSMAJORVERSION)
		  			  last_version=last_version+"#{str}"
			  elsif (m1.to_i() >= GNMSMAJORVERSION) && (m2.to_i() > GNMSMINORVERSION)
		  			  last_version=last_version+"#{str}"
			  elsif (m1.to_i() >= GNMSMAJORVERSION) && (m2.to_i() >= GNMSMINORVERSION)
				  if m3 != nil
					  if m3 > GNMSTAGVERSION
			  			  last_version=last_version+"#{str}"
					  end
				  end
			  end
		  end
		 end
		 Gtk.thread_protect do
		 hbox=Gtk::HBox.new
		 labelf=Gtk::Label.new("Choose version")
		 hbox.add labelf
                 last_version.split(/\n/).each {|v|
                   combo_last_version.append_string(v)
                 }
		 combo_last_version.show
		 hbox.add combo_last_version
		 vbox.add hbox
		  combo_last_version.signal_connect("changed") {|val|
			 if val.text != ""
				 text.buffer.delete(text.buffer.start_iter,text.buffer.end_iter)
				 text.buffer.insert_at_cursor(get_changelog(combo_last_version.active_text).to_s)
			 end
		  }
		 end
	 	end
	 rescue
		  #no update available
  		  Gtk.thread_protect do
			  window.set_size_request(350,25)
			  label=Gtk::Label.new("No update available for version : "+GNMSVERSION)
			  vbox.add label
		  end
     	end
	Gtk.thread_protect do
	 if last_version != ""
		changelog=get_changelog(combo_last_version.active_text)
		text.cursor_visible=false
		text.set_size_request(-1,225)
		text.set_editable(false)
		text.show
		scrolled_window = Gtk::ScrolledWindow.new(nil, nil)
		scrolled_window.border_width=2
		scrolled_window.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)  
		scrolled_window.show
		scrolled_window.add(text)
		text.grab_focus
		text.freeze
		text.buffer.insert_at_cursor(changelog.to_s)
		vbox.add scrolled_window
	 end
	 window.show_all
	 window.signal_connect("key_press_event") {|w,e|
		if e.keyval == Gdk::Keyval::GDK_Escape
   	  window.destroy
		end
	 }
	 window.signal_connect("destroy") {|w,e|
		  $win.show_update_menu_entry()
	 }
	 end
  }
end
