
module Gtk
  class CList < TreeView
	 attr_accessor :nb_event

	def set_sort_column(col_src,col_dst)
		get_column(col_src-1).set_sort_column_id(col_dst)
	end
    def initialize(ttitle)
     @nb_event=0
      super(Gtk::ListStore.new(Gdk::Color, *ttitle.collect{|d| d.class}))
		set_enable_search(false)
      i=1
		renderer=Gtk::CellRendererText.new()
		#renderer.background = "pink"
      ttitle.each {|col|
		column=Gtk::TreeViewColumn.new(col, 
                              	renderer,{
                                 	 :background_gdk => 0,
                                 	 :text => i
											  })
		column.set_sort_column_id(i)
		append_column(column)
		i+=1
      }
    end

    def append(ttext)
      row=model.append
		set_bg_color(ttext[1], row)
		i=1
		ttext.each {|val|
	      row[i]=val
			i+=1
		}
		@nb_event+=1
    end

    def prepend(ttext)
		row=model.prepend
		if ttext
		   set_bg_color(ttext[1], row)
		   i=1
		   ttext.each {|val|
			   row[i]=val
			   i+=1
		   }
		   @nb_event+=1
		end
    end

    def remove(row)
		if model.remove(row)
			@nb_event-=1
		end
	 end

    def clear()
		model.clear()
		@nb_event=0
    end

	 def get_value(iter, column)
			model.get_value(iter, column) unless iter == nil
	 end

	#
	#	change title of each column
	#
	def changed_all_column_name(table)
		indx=0
		columns.each do |col|
			col.set_title(table[indx])
			indx+=1
		end
	end

	#
	#	change title to str of column col 
	#
	def changed_column_name(col,str)
		get_column(col).set_title(str) unless col > (columns.size - 1)
	end


	private
	def set_bg_color(val, row)
		case val
		when ""
		when "PANIC"
			row[0]=$red
		when "ALERT"
			row[0]=$orange
		when "ERR"
			row[0]=$yellow
		when "WARN"
			row[0]=$blue
		when "INFO"
			row[0]=$green
		else
			#perhaps it s not a level it s a status ?
			set_bg_color(get_level_from_status(val),row)
		end
	end
  end

  class ImageComboList < Gtk::ComboBox

  @subdir = String.new
  @filename = String.new
  @filetype = String.new

    def filename
       return "#{@subdir}/#{self.active_iter[1]}.#{@filetype}"
    end

   def name
      return "#{self.active_iter[1]}"
   end

    def selected
       if self
	  return self.active
       else
	 return nil
       end
    end

    def initialize(subd, filename, filetype="png")
      @subdir = subd
      @filename = filename
      @filetype = filetype

      item_active = 0

      model = Gtk::ListStore.new(Gdk::Pixbuf, String)
      menu_icon_size = Gtk::IconSize.lookup(Gtk::IconSize::MENU)[0]
      pos = 0
      for typefile in Dir["#{PIXMAP_PATH}/#{subd}/*#{filetype}"].sort
	iter = model.append
	iter[0] =  Gdk::Pixbuf.new(typefile, menu_icon_size, menu_icon_size)
	iter[1] = typefile[PIXMAP_PATH.length+subd.length + 2 ,typefile.size - PIXMAP_PATH.length - subd.length - 2 - filetype.length - 1]
	if filename and iter[1] == filename
          item_active = pos
	end
	pos +=1
      end

      super(model)
      self.active = item_active

      # column 1
      renderer = Gtk::CellRendererPixbuf.new
      self.pack_start(renderer, false)
      self.set_attributes(renderer, :pixbuf => 0)

      # column 2
      renderer = Gtk::CellRendererText.new
      self.pack_start(renderer, true)
      self.set_attributes(renderer, :text => 1)

      #self.signal_connect("changed") do
      #  p self.filename
      #end
    end
  end

end

