require "#{GNMSLIB}"+'/monitor/client/jmx/jmx_attr_monitoring'

class JmxMonitoring

   def initialize (st, jmx_name, proto, pt, ath=nil)
	@state=st
	@jmxref=jmx_name
	@protocol=proto
	@port=pt
	@auth=ath	
	@attributes=Hash.new
   end		

	def oper()
		return TESTOP[@oper]
	end

	def get_ref()
		return @jmxref
	end

	def get_protocol()
		return @protocol
	end

	def set_protocol(proto)
		@protocol=proto
	end

	def get_port()
		return @port
	end

	def set_port(pt)
		@port=pt
	end

	def get_auth()
		return @auth
	end

	def set_auth(ath)
		@auth=ath
	end

	def get_state()
		return @state
	end
	
	def set_state(st)
		@state=st
	end
	
	def get_attributes()
		return @attributes
	end

	def clear_attributes()
		@attributes=Hash.new
	end

	def add_attribute(name, op, val, sev)
		print op,"\n"
		@attributes[name]=JmxAttributeMonitoring.new(name, op, val, sev)
	end

	def exist_attribute(name)
		return @attributes.include?(name)
	end

	def del_attribute(name)
		return @attributes.delete(name)
	end

	def attribute_size()
		return @attributes.size
	end

	def active?()
		return @state==1
	end

end #class
