class JMXRef
   attr_accessor :name, :description, :mbean, :attribute

	TABLENAME='jmx_ref'
########global management#########

#
#	add an jmx_ref
#	arg n for uniq name, descr the description, mbean and attribute
#	return true if deleted otherwise false
#
def JMXRef::add_jmx_ref(n, descr, calc, attr)
	if $jmx_refs[n] == nil
		$jmx_refs[n] = JMXRef.new(n, descr, calc, attr)
		return true
	end
	return false
end


#
#	delete an jmx_ref
#	return true is entry delete otherwise false
#
def JMXRef::del_jmx_ref(n)
	if !$jmx_refs[n].used?()
		$jmx_refs.delete(n)
		return true
	end
	return false
end

def  JMXRef::write_db_jmxref()
	if defined?($db) && ($db !=nil)
		$db.transaction
		ps=db_delete_all_prp(TABLENAME)
		if ps
			ps.execute()
			stmt=db_insert_ref_prp4(TABLENAME)
			$jmx_refs.each_value do |jmx_ref|
				stmt.execute(jmx_ref.name, jmx_ref.description, jmx_ref.mbean, jmx_ref.attribute)
			end
			$db.commit
		else
			$db.rollback
		end
	end
end

def JMXRef::read_db_jmxref()
	if defined?($db) && ($db !=nil)
		db_select_all_prp(TABLENAME).execute do |rs|
			rs.each do |name, description, mbean, attribute|
				add_jmx_ref(name,description,mbean,attribute)
			end
		end
	end
end

#
#	return a table of all jmxrefs name
#
def JMXRef::get_jmx_refs_name()
	name_t=[]
	$jmx_refs.each_key {|name|
		name_t.push name
	}
	return name_t
end

#
#	check if a given jmx ref name is defined
#
def JMXRef::jmx_ref_exist?(name)
	return $jmx_refs[name] != nil
end

#
#	return number of jmx ref
#
def JMXRef::jmx_ref_nb_entry()
	return $jmx_refs.size
end

########end global management#########


   def initialize (n, descr, calc, attr)
		#name is the identifier, it must be uniq
	@name=n
	@description=descr
	@mbean=calc
	@attribute=attr
	@nb_use=0
   end

   def add_use()
	   @nb_use+=1
   end

   def del_use()
	   @nb_use-=1
   end

   def used?()
	   return @nb_use>0 
   end

   def to_str()
	   print "JMXRef: ", @name, " ", @description, " ", @mbean, " ", @attribute
   end


end #class
