class OIDRef
   attr_accessor :name, :description, :value

	TABLENAME='oid_ref'
########global management#########

#
#	add an oid_ref
#	arg n for uniq name, descr the description and calc the calcul to do
#	return true if deleted otherwise false
#
def OIDRef::add_oid_ref(n, descr, calc)
	if $oid_refs[n] == nil
		$oid_refs[n] = OIDRef.new(n, descr, calc)
		return true
	end
	return false
end


#
#	delete an oid_ref
#	return true is entry delete otherwise false
#
def OIDRef::del_oid_ref(n)
	if !$oid_refs[n].used?()
		$oid_refs.delete(n)
		return true
	end
	return false
end

def  OIDRef::write_db_oidref()
	if defined?($db) && ($db !=nil)
		$db.transaction
		ps=db_delete_all_prp(TABLENAME)
		if ps
			ps.execute()
			stmt=db_insert_ref_prp(TABLENAME)
			$oid_refs.each_value do |oid_ref|
				stmt.execute(oid_ref.name, oid_ref.description, oid_ref.value)
			end
			$db.commit
		else
			$db.rollback
		end
	end
end

def OIDRef::write_oidref_conf_file(fic_name=OIDREFS_CONF_FILE)
 	   field_separator='~'
  		fic=Tempfile.new(File.basename(fic_name))
		$oid_refs.each_value do |oid_ref|
			fic.puts "#{oid_ref.name}#{field_separator}#{oid_ref.description}#{field_separator}#{oid_ref.value}"
		end
		fic.close()
		FileUtils.move(fic.path, fic_name)
end

def OIDRef::read_db_oidref()
	if defined?($db) && ($db !=nil)
		db_select_all_prp(TABLENAME).execute do |rs|
			rs.each do |name, description, value|
				add_oid_ref(name,description,value)
			end
		end
	end
end

def OIDRef::read_oidref_conf_file(fic=OIDREFS_CONF_FILE)
	field_separator='~'
	if FileTest.exist?(fic)
		fic = File.new(fic,'r')
		lign=fic.gets
		while lign
			lign_t = lign.split(field_separator)
			if lign_t.size() == 3
				add_oid_ref(lign_t[0],lign_t[1],lign_t[2].chomp())
			end
			lign=fic.gets
		end
		fic.close
	else
		puts "oidrefs conf file not found"
	end
end

#
#	return a table of all oidrefs name
#
def OIDRef::get_oid_refs_name()
	name_t=[]
	$oid_refs.each_key {|name|
		name_t.push name
	}
	return name_t
end

#
#	check if a given oid ref name is defined
#
def OIDRef::oid_ref_exist?(name)
	return $oid_refs[name] != nil
end

#
#	return number of oid ref
#
def OIDRef::oid_ref_nb_entry()
	return $oid_refs.size
end

########end global management#########


	def initialize (n, descr, calc)
		#name is the identifier, it must be uniq
		@name=n
		@description=descr
		@value=calc
		@nb_use=0	
	end

	def add_use()
		@nb_use+=1
	end

	def del_use()
		@nb_use-=1
	end

	def used?()
		return @nb_use>0 
	end
	
	def to_str()
		print "OIDRef: ", @name, " ", @description, " ", @value
	end


end #class
