
#
# return the value corresponding to the good attribute.
# a bug in wmic does not return only requested attributes
#
def find_separated_value_from_two_lines(l1, l2, attribute)
	if (l1 == nil) || (l2 == nil)
		return nil
	end
	attrt=l1.split('|')
	valuet=l2.split('|')
	if attrt.index(attribute) == nil
		return nil
	end
	return valuet[attrt.index(attribute)]
end


#
# return the ComputerSystem description using a wmi request
#
def get_wmi_description(login, password, host)
	resultt=wmi_request(login, password, host, "select Description from Win32_ComputerSystem")

	#format is as below
	#CLASS: Win32_ComputerSystem
	#Description|Name
	#AT/AT COMPATIBLE|KOMA-PC
	return find_separated_value_from_two_lines(resultt[1], resultt[2], "Description")
end


#
# return the bootup state using a wmi request
#
def get_wmi_boot_state(login, password, host)
	resultt=wmi_request(login, password, host, "select BootupState from Win32_ComputerSystem")
	return find_separated_value_from_two_lines(resultt[1], resultt[2], "BootupState")	
end

#
# return the thermal state severity using a wmi request
#
def get_wmi_thermal_state(login, password, host)
	resultt=wmi_request(login, password, host, "select ThermalState from Win32_ComputerSystem")
	value=find_separated_value_from_two_lines(resultt[1], resultt[2], "ThermalState")
	if value.to_i == 1
		return "Other"
	elsif value.to_i == 3
		return "Safe"
	elsif value.to_i == 4
		return "Warning"
	elsif value.to_i == 5
		return "Critical"
	elsif value.to_i == 6
		return "Nonrecoverable"
	elsif value.to_i == 2
		return "Unkown"
	end
	return nil

#from http://msdn.microsoft.com/en-us/library/aa394102.aspx
#1 (0x1) Other
#2 (0x2) Unknown
#3 (0x3) Safe
#4 (0x4) Warning
#5 (0x5) Critical
#6 (0x6)Nonrecoverable

end

#
# return the number of processor on the host using a wmi request
#
def get_wmi_nb_proc(login, password, host)
	resultt=wmi_request(login, password, host, "select NumberOfProcessors from Win32_ComputerSystem")
	return find_separated_value_from_two_lines(resultt[1], resultt[2], "NumberOfProcessors")
end

#
# return system type using a wmi request
#
def get_wmi_system_type(login, password, host)
	resultt=wmi_request(login, password, host, "select SystemType from Win32_ComputerSystem")
	return find_separated_value_from_two_lines(resultt[1], resultt[2], "SystemType")
end

#
# return the concatenation of OS and SP level using a wmi request
#
def get_wmi_os(login, password, host)
	resultt=wmi_request(login, password, host, "select Name,CSDVersion from Win32_OperatingSystem")
	val1=find_separated_value_from_two_lines(resultt[1], resultt[2], "Name")
	val2=find_separated_value_from_two_lines(resultt[1], resultt[2], "CSDVersion")
	if !val1
		return nil
	end
	if !val2 || (val2 == "")
		val2=0
	end
	return "#{val1} SP#{val2}"
end

#
# return product type using a wmi request
#
def get_wmi_product_type(login, password, host)
#1 Work Station
#2 Domain Controller
#3 Server
#seems it does not exist in windows 2000 server
	resultt=wmi_request(login, password, host, "select ProductType from Win32_OperatingSystem")
	value=find_separated_value_from_two_lines(resultt[1], resultt[2], "ProductType")	
	if value.to_i == 1
		return "Workstation"
	elsif value.to_i == 2
		return "Domain Controller"
	elseif value.to_i == 3
		return "Server"
	end
	return nil	
end

#
# return host name using a wmi request
#
def get_wmi_name(login, password, host)
	resultt=wmi_request(login, password, host, "select Name from Win32_ComputerSystem")
	return find_separated_value_from_two_lines(resultt[1], resultt[2], "Name")	
end

#
# return domain name using a wmi request
#
def get_wmi_domain(login, password, host)
	resultt=wmi_request(login, password, host, "select Domain from Win32_ComputerSystem")
	return find_separated_value_from_two_lines(resultt[1], resultt[2], "Domain")	
end

