class WMIRef
   attr_accessor :name, :description, :value

	TABLENAME='wmi_ref'
########global management#########

#
#	add an wmi_ref
#	arg n for uniq name, descr the description and calc the calcul to do
#	return true if deleted otherwise false
#
def WMIRef::add_wmi_ref(n, descr, calc)
	if $wmi_refs[n] == nil
		$wmi_refs[n] = WMIRef.new(n, descr, calc)
		return true
	end
	return false
end


#
#	delete an wmi_ref
#	return true is entry delete otherwise false
#
def WMIRef::del_wmi_ref(n)
	if !$wmi_refs[n].used?()
		$wmi_refs.delete(n)
		return true
	end
	return false
end

def  WMIRef::write_db_wmiref()
	if defined?($db) && ($db !=nil)
		$db.transaction
		ps=db_delete_all_prp(TABLENAME)
		if ps
			ps.execute()
			stmt=db_insert_ref_prp(TABLENAME)
			$wmi_refs.each_value do |wmi_ref|
				stmt.execute(wmi_ref.name, wmi_ref.description, wmi_ref.value)
			end
			$db.commit
		else
			$db.rollback
		end
	end
end

def WMIRef::write_wmiref_conf_file(fic_name=WMIREFS_CONF_FILE)
 	   field_separator='~'
  		fic=Tempfile.new(File.basename(fic_name))
		$wmi_refs.each_value do |wmi_ref|
			fic.puts "#{wmi_ref.name}#{field_separator}#{wmi_ref.description}#{field_separator}#{wmi_ref.value}"
		end
		fic.close()
		FileUtils.move(fic.path, fic_name)
end

def WMIRef::read_db_wmiref()
	if defined?($db) && ($db !=nil)
		db_select_all_prp(TABLENAME).execute do |rs|
			rs.each do |name, description, value|
				add_wmi_ref(name,description,value)
			end
		end
	end
end

def WMIRef::read_wmiref_conf_file(fic=WMIREFS_CONF_FILE)
	field_separator='~'
	if FileTest.exist?(fic)
		fic = File.new(fic,'r')
		lign=fic.gets
		while lign
			lign_t = lign.split(field_separator)
			if lign_t.size() == 3
				add_wmi_ref(lign_t[0],lign_t[1],lign_t[2].chomp())
			end
			lign=fic.gets
		end
		fic.close
	else
		puts "wmirefs conf file not found"
	end
end

#
#	return a table of all wmirefs name
#
def WMIRef::get_wmi_refs_name()
	name_t=[]
	$wmi_refs.each_key {|name|
		name_t.push name
	}
	return name_t
end

#
#	check if a given wmi ref name is defined
#
def WMIRef::wmi_ref_exist?(name)
	return $wmi_refs[name] != nil
end

#
#	return number of wmi ref
#
def WMIRef::wmi_ref_nb_entry()
	return $wmi_refs.size
end

########end global management#########


   def initialize (n, descr, calc)
		#name is the identifier, it must be uniq
      @name=n
      @description=descr
      @value=calc
		@nb_use=0
	end

	def add_use()
		@nb_use+=1
	end

	def del_use()
		@nb_use-=1
	end

	def used?()
		return @nb_use>0 
	end
	
	def to_str()
		print "WMIRef: ", @name, " ", @description, " ", @value
	end


end #class
