
class SnmpAnalyzer

  def initialize(buff)
    @buff=buff

	 @mib=SNMP::MIB.new()
	 libs=["SNMPv2-SMI", "SNMPv2-MIB", "IF-MIB", "IP-MIB", "TCP-MIB", "UDP-MIB"]
	 libs.each do |lb|
		@mib.load_module(lb)
	 end
    @sender = Thread.start do
   	 while $config.snmptrap_mon
      	   send_messages if buff.full?
      	   sleep(1)
	   Thread.pass
   	 end
    end
	$log.debug("end of SnmpAnalyzer thread")
  end
  
  def get_thread
    @sender
  end

	#
	#	convert oid_name to oid, return nil if error
	#
	def to_oid(oid_name)
		oid=nil
		begin
			oid=@mib.oid(oid_name).to_s
		rescue
			$log.error("SNMP trap: dont understand #{oid_name}")
		end
		return oid
	end

  def send_messages
    while @buff.has_more?
      snmptrap_msg=@buff.get
		if snmptrap_msg != nil
			src=snmptrap_msg.source_ip
			if $host[src] != nil && $host[src].snmptrap_monitoring.size() > 0
				find_oid_val=nil
				snmptrap_vers=0
			  if snmptrap_msg.class == SNMP::SNMPv2_Trap
				 snmptrap_vers=2
				 find_oid_val=snmptrap_msg.trap_oid().join('.')
			  elsif SNMP::SNMPv1_Trap
				 snmptrap_vers=1
				 find_oid_val=snmptrap_msg.enterprise.join('.')
				 if snmptrap_msg.generic_trap() == :enterpriseSpecific
			  		 find_oid_val="#{find_oid_val}.6.#{snmptrap_msg.specific_trap}"
				 else
					 find_oid_val="#{find_oid_val}."+snmptrap_msg.generic_trap()
				 end
			  else 
				  $log.error("unkwown Snmp Trap version")
			  end
			  if find_oid_val != nil
				 $host[src].snmptrap_monitoring.each_value do |snmptrap_mon|
					 if snmptrap_mon.active?() 
					    trap_ref_value=to_oid($snmptrap_refs[snmptrap_mon.get_snmptrap_ref()].get_oid())
						 find_oid_value=to_oid(find_oid_val)
						 if (trap_ref_value == find_oid_value) && (find_oid_value!=nil)
							$event_win.add_event(EventWindow::TRAP_EVENT_TYPE, get_level_from_status($status[snmptrap_mon.raw_severity()-1]), $host[src], "Snmp Trap(v#{snmptrap_vers}): #{$snmptrap_refs[snmptrap_mon.get_snmptrap_ref()].name}")
							if $status_value[snmptrap_mon.raw_severity()-1] > $host[src].trap_sev
								$host[src].set_trap_severity(snmptrap_mon.raw_severity()-1)
							end							
							break
						 end
					 end
				 end
			  end
			end
		end
	 end
  end

end
