class SnmpTrapRef
   attr_accessor :name, :description

	TABLENAME='snmptrap_ref'
#############global management###############
#
#	add an snmptrap_ref
#	arg n for uniq name, descr the description and calc the calcul to do
#	return true if deleted otherwise false
#
def SnmpTrapRef::add_snmptrap_ref(n, descr, calc)
	if $snmptrap_refs[n] == nil
		$snmptrap_refs[n] = SnmpTrapRef.new(n, descr, calc)
		return true
	end
	return false
end

#
#	delete an snmptrap_ref
#	return true is entry delete otherwise false
#
def SnmpTrapRef::del_snmptrap_ref(n)
	if !$snmptrap_refs[n].used?()
		$snmptrap_refs.delete(n)
		return true
	end
	return false
end

def  SnmpTrapRef::write_db_snmptrapref()
	if defined?($db) && ($db !=nil)
		$db.transaction
		db_delete_all_prp(TABLENAME).execute()
		stmt=db_insert_ref_prp(TABLENAME)
		$snmptrap_refs.each_value do |snmptrap_ref|
			stmt.execute(snmptrap_ref.name, snmptrap_ref.description, snmptrap_ref.value)
		end
		$db.commit
	end
end

def SnmpTrapRef::write_snmptrapref_conf_file(fic_name=SNMPTRAPREFS_CONF_FILE)
 	   field_separator='~'
  		fic=Tempfile.new(File.basename(fic_name))
		$snmptrap_refs.each_value do |snmptrap_ref|
			fic.puts "#{snmptrap_ref.name}#{field_separator}#{snmptrap_ref.description}#{field_separator}#{snmptrap_ref.value}"
		end
		fic.close()		
		if !FileUtils.move(fic.path, fic_name)
			$log.error("Can not save snmp trap ref conf file")
		end
end

def SnmpTrapRef::read_db_snmptrapref()
	if defined?($db) && ($db !=nil)
		db_select_all_prp(TABLENAME).execute do |rs|
			rs.each do |name, description, value|
				add_snmptrap_ref(name,description,value)
			end
		end
	end
end

def SnmpTrapRef::read_snmptrapref_conf_file(fic=SNMPTRAPREFS_CONF_FILE)
	field_separator='~'
	if FileTest.exist?(fic)
		fic = File.new(fic,'r')
		lign=fic.gets
		while lign
			lign_t = lign.split(field_separator)
			if lign_t.size() == 3
				add_snmptrap_ref(lign_t[0],lign_t[1],lign_t[2].chomp())
			end
			lign=fic.gets
		end
		fic.close
	else
		puts "SnmpTrapRefs conf file not found"
	end
end

#
#	return a table of all SnmpTrapRef name
#
def SnmpTrapRef::get_snmptrap_refs_name()
	name_t=[]
	$snmptrap_refs.each_key {|name|
		name_t.push name
	}
	return name_t
end

def SnmpTrapRef::snmptrap_ref_exist?(name)
	return $snmptrap_refs[name] != nil
end
#############end global management###############

   def initialize (n, descr, oid)
		#name is the identifier, it must be uniq
      @name=n
      @description=descr
      @value=oid
		@nb_use=0
	end

	def add_use()
		@nb_use+=1
	end

	def del_use()
		@nb_use-=1
	end

	def used?()
		return @nb_use>0 
	end
	
	def to_str()
		print "SnmpTrapRef: ", @name, " ", @description, " ", @value
	end

	def get_oid()
		return @value
	end

	def value()
		return @value
	end

	def set_value(oid)
		 @value=oid
	end

end #class
