#
#Could not find default MIB directory, tried:
#  /usr/share/ruby/snmp/mibs
#  /usr/lib/ruby/data/ruby/snmp/mibs
#
#

class SnmpTrapServer
  #check if snmp lib support traps
  def snmp_traps_supported?
    begin
      SNMP::UDPServerTransport.new('localhost', 9999, Socket::AF_INET)
      return true
    rescue ArgumentError
      return false
    end
  end

  def initialize(buff)
    @buff=buff
    begin
      if !snmp_traps_supported?()
        $log.error("Ruby SNMP lib version is too old, you must at least upgrade to 1.0.1")
      end
      @server = SNMP::TrapListener.new(:Host=>'', :Port => $config.snmptrap_port, :Community => $config.snmptrap_community) do |manager|
        $log.info("SNMP trap Server: listening on udp port #{$config.snmptrap_port}")
        manager.on_trap_default do |trap|
          @buff.put trap
          $log.debug("Trap received: #{trap.inspect}")
        end
      end
    rescue Errno::EADDRINUSE => msg
      $log.fatal("Syslog Server: #{msg}, socket in use")
      raise Errno::EADDRINUSE
    rescue Errno::EACCES => msg
      $log.fatal("Syslog Server: #{msg}, need root perms")
      raise Errno::EACCES
    rescue Exception => e
      raise e
    end
  end

  def close_socket()
    @server.exit() unless @server == nil
  end

  def get_thread
    @server
  end
end
