require "#{GNMSLIB}"+'/monitor/server/syslog/syslog_server'
require "#{GNMSLIB}"+'/monitor/server/msg_buffer'
require "#{GNMSLIB}"+'/monitor/server/syslog/syslog_analyzer'

class SyslogCapture
  def initialize()
	 if $config.syslog_mon
		buff=MsgBuffer.new(1)
		begin
			@input = SyslogServer.new(buff)
			@output = SyslogAnalyzer.new(buff)
		rescue Errno::EADDRINUSE => msg
		rescue Errno::EACCES => msg
		 $log.error("Syslog Server: not started")
		end
	 end
	end

	def stop()
		if defined?(@input) && (@input != nil)
			@input.close_socket()
			Thread.kill(@input.get_thread())
			$log.debug("end of SyslogServer thread")
			#output thread will be done auto
		end
	end

end
