class SyslogRef
   attr_accessor :name, :description

	TABLENAME='syslog_ref'
#############global management###############
#
#	add an syslog_ref
#	arg n for uniq name, descr the description and calc the calcul to do
#	return true if deleted otherwise false
#
def SyslogRef::add_syslog_ref(n, descr, calc)
	if $syslog_refs[n] == nil
		$syslog_refs[n] = SyslogRef.new(n, descr, calc)
		return true
	end
	return false
end

#
#	delete an syslog_ref
#	return true is entry delete otherwise false
#
def SyslogRef::del_syslog_ref(n)
	if !$syslog_refs[n].used?()
		$syslog_refs.delete(n)
		return true
	end
	return false
end

def  SyslogRef::write_db_syslogref()
	if defined?($db) && ($db !=nil)
		$db.transaction
		db_delete_all_prp(TABLENAME).execute()
		stmt=db_insert_ref_prp(TABLENAME)
		$syslog_refs.each_value do |syslog_ref|
			stmt.execute(syslog_ref.name, syslog_ref.description, syslog_ref.value.source)
		end
		$db.commit
	end
end

def SyslogRef::write_syslogref_conf_file(fic_name=SYSLOGREFS_CONF_FILE)
 	   field_separator='~'
  		fic=Tempfile.new(File.basename(fic_name))
		$syslog_refs.each_value do |syslog_ref|
			fic.puts "#{syslog_ref.name}#{field_separator}#{syslog_ref.description}#{field_separator}#{syslog_ref.value.source}"
		end
		fic.close()
		if !FileUtils.move(fic.path, fic_name)
			$log.error("Can not save syslog ref conf file")
		end
end

def SyslogRef::read_db_syslogref()
	if defined?($db) && ($db !=nil)
		db_select_all_prp(TABLENAME).execute do |rs|
			rs.each do |name, description, value|
				add_syslog_ref(name,description,value)
			end
		end
	end
end

def SyslogRef::read_syslogref_conf_file(fic=SYSLOGREFS_CONF_FILE)
	field_separator='~'
	if FileTest.exist?(fic)
		fic = File.new(fic,'r')
		lign=fic.gets
		while lign
			lign_t = lign.split(field_separator)
			if lign_t.size() == 3
				add_syslog_ref(lign_t[0],lign_t[1],lign_t[2].chomp())
			end
			lign=fic.gets
		end
		fic.close
	else
		puts "syslogrefs conf file not found"
	end
end

#
#	return a table of all syslogref name
#
def SyslogRef::get_syslog_refs_name()
	name_t=[]
	$syslog_refs.each_key {|name|
		name_t.push name
	}
	return name_t
end

def SyslogRef::syslog_ref_exist?(name)
	return $syslog_refs[name] != nil
end
#############end global management###############

   def initialize (n, descr, re)
		#name is the identifier, it must be uniq
      @name=n
      @description=descr
		#here value is a regexp
      @value=Regexp.new(re)
		@nb_use=0
	end

	def add_use()
		@nb_use+=1
	end

	def del_use()
		@nb_use-=1
	end

	def used?()
		return @nb_use>0 
	end
	
	def to_str()
		print "SyslogRef: ", @name, " ", @description, " ", @value
	end

	def get_regex()
		return @value
	end

	def value()
		return @value
	end

	def set_value(re)
		 @value=Regexp.new(re)
	end

end #class
