class SyslogServer

  def initialize(buff)
    require 'socket'
    @port = $config.syslog_port
    @buff=buff
    Socket.do_not_reverse_lookup = true
    @server = UDPSocket.open
    begin
      $log.info("Syslog Server: listening on udp port #{@port}")
      @server.bind("", @port)
    rescue Errno::EADDRINUSE => msg
      $log.fatal("Syslog Server: #{msg}, socket in use")
      raise Errno::EADDRINUSE
    rescue Errno::EACCES => msg
      $log.fatal("Syslog Server: #{msg}, need root perms")
      raise Errno::EACCES
    rescue Exception => msg
      raise msg
    end

    @listener = Thread.start do
      while $config.syslog_mon
        begin
          msg = @server.recvfrom(1024)
          #extract peer info: domain, port, name, and IP address
          @buff.put Time.new.to_s()+'|'+"#{msg[1][3]}#{msg[0]}"
          Thread.pass if @buff.full?
        rescue Exception => msg
          #catch when stream is closed by close() method
        end
      end
    end
  end

  def close_socket()
    @server.close unless @server == nil
  end

  def get_thread
    @listener
  end
end
