#
# Thread to listen for hosts
#
require 'resolv'

#
#	auto save map
#
def tauto_save_map()
	$log.debug("in tauto_save_map")
	Thread.start {
		while $config.auto_save_map
			for minute in 1..$config.auto_save_map_value.to_i
				sleep(60)
				if !$config.auto_save_map
					break
				end
			end
			$log.info("Auto Saving map every #{$config.auto_save_map_value} minutes launch")
	                write_xml()
		end
	del_monitoring_thread("Map autosaving")
	}
end

#
#	monitor custom
#
def tmonitorcustom()
	Thread.start {
   	while $config.custom_mon
			  $log.debug("in tmonitorcustom every #{$config.custom_mon_delay} second")
			  sleep($config.custom_mon_delay.to_i)
			  ip_table=$host.keys
			  for ip in ip_table
					if !$config.custom_mon
						break
					end
				  begin
					  if $host[ip].status != UNMANAGED
						  test_monitored_custom(ip)
					  end
				  rescue Exception => msg
				     $log.error("Custom monitor: #{msg}")
				     $event_win.add_event(EventWindow::CUSTOM_EVENT_TYPE, "ERR", $host[ip], msg)
				  end
			  end
		end
	}
end

#
#	monitor snmp oid refs
#
def tmonitorsnmp()
	Thread.start {
   	while $config.snmp_mon
		  $log.debug("in tmonitorsnmp every #{$config.snmp_mon_delay} second")
		  sleep($config.snmp_mon_delay.to_i)
		  ip_table=$host.keys
		  for ip in ip_table
				if !$config.snmp_mon
					break
				end
				begin
					if $host[ip] && ($host[ip].status != UNMANAGED)
						test_monitored_snmp(ip)
					end
				rescue Exception => msg		
					$log.error(msg)
					$event_win.add_event(EventWindow::SNMP_EVENT_TYPE, "INFO", $host[ip], msg)
				end
		  end
		end
	}
end

#
#	monitor wmi refs
#
def tmonitorwmi()
	Thread.start {	
	   	while $config.wmi_mon
		  $log.debug("in tmonitorwmi every #{$config.wmi_mon_delay} second")
		  sleep($config.wmi_mon_delay.to_i)
		  ip_table=$host.keys
		  for ip in ip_table
				if !$config.wmi_mon
					break
				end
				begin
					if $host[ip] && ($host[ip].status != UNMANAGED)
						test_monitored_wmi(ip)
					end
				rescue Exception => msg	
					$log.error(msg)
					$event_win.add_event(EventWindow::WMI_EVENT_TYPE, "INFO", $host[ip], msg)	
				end
		  end
		end
	}
end

#
#	monitor jmx refs
#
def tmonitorjmx()
	Thread.start {	
	   	while $config.jmx_mon
		  $log.debug("in tmonitorjmx every #{$config.jmx_mon_delay} second")
		  sleep($config.jmx_mon_delay.to_i)
		  ip_table=$host.keys
		  for ip in ip_table
				if !$config.jmx_mon
					break
				end
				begin
					if $host[ip] && ($host[ip].status != UNMANAGED)
						test_monitored_jmx(ip)
					end
				rescue Exception => msg
					$log.error("tmonitorjmx: #{msg}")
					$event_win.add_event(EventWindow::JMX_EVENT_TYPE, "INFO", $host[ip], msg)
				end
		  end
		end
	}
end

#
#	monitor host and service(s)
#
def tmonitorport()
  Thread.start {
    while $config.port_mon
      $log.debug("in tmonitorport every #{$config.port_mon_delay} second")
      sleep($config.port_mon_delay.to_i)
      #retry already known hosts, if NORMAL test his monitored ports
      ip_table=$host.keys
      for ip in ip_table
        if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
          if $host[ip] != nil && $host[ip].status != UNMANAGED
            #puts "trying .... #{ip}"
            if ping(ip)
              #test monitored ports
              #puts "ping ok here #{ip} #{$host[ip].service.size()}"
              if $config.port_mon && $host[ip] && ($host[ip].service.size() > 0)
                #test if monitored ports are ok
                sev_st = test_monitored_ports(ip)
                if sev_st <= 0
                  $host[ip].set_service_severity(NORMAL)
                else
                  $host[ip].set_service_severity(sev_st)
                end
              end
              #host is up
              if $host[ip] && $host[ip].avail_sev != NORMAL
                $host[ip].set_avail_severity(NORMAL)
                $event_win.add_event(EventWindow::AVAIL_EVENT_TYPE, "INFO", $host[ip], "Ping OK")
              end
            else
              #puts "ping nok here #{ip} #{$host[ip].service.size()}"
              #test monitored ports here too, as the ping can be disabled but services up
              if $config.port_mon && $host[ip] && ($host[ip].service.size() > 0)
                #test if monitored ports are ok
                sev_st = test_monitored_ports(ip)
                if sev_st <= 0
                  $host[ip].set_service_severity(NORMAL)
                else
                  $host[ip].set_service_severity(sev_st)
                end
              end
              #host is down
              if $host[ip] != nil
                #puts "ping nok #{ip}"
                if $host[ip].avail_sev != CRITICAL
                  $host[ip].set_avail_severity(CRITICAL)
                end
		#here we only push the event when only the availability sev is set
		if (($host[ip].avail_sev == CRITICAL) and ($host[ip].snmp_sev <= UNMANAGED) and ($host[ip].custom_sev <= UNMANAGED) and ($host[ip].trap_sev <= UNMANAGED) and ($host[ip].service_sev <= UNMANAGED) and ($host[ip].wmi_sev <= UNMANAGED) and ($host[ip].syslog_sev <= UNMANAGED) and ($host[ip].jmx_sev <= UNMANAGED))
                  $event_win.add_event(EventWindow::AVAIL_EVENT_TYPE, "PANIC", $host[ip], "Ping KO")
		end
              end
            end
          end
        end
      end
    end
  }
end

#
#  try to find os for given ip
#
def tresolvos()
	Thread.start {
		while $config.node_resolving
			$log.debug("in tresolos #{$config.node_resolving_delay.to_i} second")
			sleep($config.node_resolving_delay.to_i) #wait before all window are maps
			ip_table=$host.keys
			for ip in ip_table
				if !$config.node_resolving
					break
				end
			  if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
				  #puts "for #{ip}"
				  if $host[ip] && ($host[ip].os == "unknown") && ($host[ip].status != CRITICAL) && ($host[ip].status != UNMANAGED)
					  begin
						  Timeout::timeout($config.node_resolving_delay.to_i) do |p|
				       		  Thread.start {
				        		 res=osfingerprint("#{ip}")
						 		 if res != "" && res != nil
						  	 	  $host[ip].os = res unless !$host[ip]
								  $host[ip].change_label() unless !$host[ip]
                          $host[ip].reload unless !$host[ip]
								 end
           					  }
				      	 sleep(p)
    					  end
  					  rescue Timeout::Error
						  $log.debug("tresolvos(): difficulty to find OS for address #{ip}")
					  end					
				  end
				end
			end
         sleep($config.node_resolving_delay.to_i)
		end
	}
end

#
#  try to find a netbios name for an IP
#
def tresolvnetbiosname()
	Thread.start {
		while $config.node_resolving
			sleep($config.node_resolving_delay.to_i) #wait before all window are maps
			  ip_table=$host.keys
			  for ip in ip_table
				if !$config.node_resolving
					break
				end
			  if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
				  if $host[ip] && $host[ip].netbios_name == "(noname)"
					  begin
						  timeout($config.node_resolving_delay.to_i) {
				       		  Thread.start {
				        	  		  res=ip2netbiosname("#{ip}")
						 	  		  if res != nil 
						  	 			  $host[ip].netbios_name = res
										  $host[ip].change_label()
							  		  end
           					  }
				      	 sleep(5)
    					  }
  					  rescue
						  $log.error("Difficulty to resolv #{ip} netbios name")
					  end
				  end
				end
			end
         sleep($config.node_resolving_delay.to_i)
		end
	}
end

#
# try to find a name for an IP
#
def tresolvip()
	Thread.start {
		while $config.node_resolving
				  $log.debug("in tresolvip every #{$config.node_resolving_delay.to_i} second")
				  sleep($config.node_resolving_delay.to_i) #wait before all window are maps
					ip_table=$host.keys
					for ip in ip_table
						if !$config.node_resolving
							break
						end
					  if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
						 if $host[ip] && !$host[ip].dns_name?
							 begin
								 timeout($config.node_resolving_delay.to_i) {
				       				 Thread.start {
									 #puts "in resolv ip #{ip}"
										begin
					        				res=Resolv.getname("#{ip}").to_s
						 					if res != ""
										 		#puts "resolved! #{res}"
						  	 			 		$host[ip].dns_name = res
										 		$host[ip].change_label()
											end
										rescue Resolv::ResolvError
										  $log.debug("tresolvip: can't find dns name for address #{ip}");
										rescue Errno::ENETUNREACH
										  $log.error("tresolvip: network is unreachable");
										end
           							 }
				      			sleep(5)
    							 }
  							 rescue
								 $log.error("Difficulty to resolv #{ip}, add it to your /etc/hosts file")
							 end
						 end
					  end
				  end
          sleep($config.node_resolving_delay.to_i)
		end
	}
end

#
# snmp discovery
# read arp, route, interface from a snmp host
#
def tresolvesnmp()
  Thread.start {
    while $config.node_resolving
      $log.debug("in tresolvesnmp every #{$config.node_resolving_delay.to_i} second")
      sleep($config.node_resolving_delay.to_i) #wait before all window are maps
      ip_table=$host.keys
      for ip in ip_table
        if !$config.node_resolving
          break
        end
        node = $host[ip]
        if node and (!defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false))
          #code here
          community_pub = $config.read_community
          community_priv = $config.write_community
          if node.get_account_id("snmp")
            community_pub, community_priv = node.get_account_id("snmp")
          end

          new_node = Struct.new(:ip, :mac, :netmask, :status)
          new_node_array = Array.new
          
          begin
            new_node_array.clear
            SNMP::Manager.open(:Host => ip, :Community => community_pub, :Version => get_snmp_version(node.get_default_inherit_snmp_version()), :Port => node.get_default_inherit_snmp_port().to_i, :Timeout => node.get_default_inherit_snmp_timeout().to_i, :Retries => node.get_default_inherit_snmp_retry().to_i) do |manager|

              #extract ip addr from interfaces
              ip_addr_t = Array.new
              interface_netmask_h = Hash.new
              manager.walk("1.3.6.1.2.1.4.20.1.1") {|vb|
                ip_addr_t.push vb.value.to_s
              }
              ip_addr_t.each {|ip|
                interface_id = nil
                netmask_addr = nil
                mac_addr = nil
                #unknown status
                status = 4
                #get interface id
                response = manager.get("1.3.6.1.2.1.4.20.1.2.#{ip}")
                response.each_varbind {|vb|
                  interface_id = vb.value.to_i
                }
                #extract mac addr for these interfaces based on ifPhysAddress
                response = manager.get("1.3.6.1.2.1.2.2.1.6.#{interface_id}")
                response.each_varbind {|vb|
                  mac_addr = vb.value.unpack('H*').join.scan(/.{2}|.+/).join(":")
                }
                #extract interface status
                response = manager.get("1.3.6.1.2.1.2.2.1.8.#{interface_id}")
                response.each_varbind {|vb|
                  status = vb.value.to_i
                }
                #get netmask
                response = manager.get("1.3.6.1.2.1.4.20.1.3.#{ip}")
                response.each_varbind {|vb|
                  netmask_addr = vb.value.to_s
                }
                interface_netmask_h[interface_id] = netmask_addr unless interface_id.nil?
                if mac_addr.nil? or mac_addr.empty? or (mac_addr == NILMAC)
                  mac_addr = Node::NOARP_PROPERTY
                end
                #print ip, " ", mac_addr, " ", netmask_addr, " ", interface_id, "\n"
                new_node_array.push new_node.new(ip, mac_addr, netmask_addr, status)
              }
              #propagate the search if requested
              if $config.active_find_node_state              
                status = 4
                manager.walk("1.3.6.1.2.1.4.22.1.2") { |vb|
                  #remove mib header and extract interface id and ip
                  ip_from_mib = vb.name.to_s.match(/^.+\.(\d+)\.(\d+\.\d+\.\d+\.\d+)$/)
                  interface_id = $1.to_i
                  ip_from_mib = $2.to_s
                  mac_from_mib = vb.value.unpack('H*').join.scan(/.{2}|.+/).join(":")
  
                  mask = DEFAULT_CLASS_C_NETMASK
                  if (interface_id >=0) and interface_netmask_h[interface_id]
                    mask = interface_netmask_h[interface_id]
                  end
                  #print ip_from_mib," ",mac_from_mib," ", mask, "\n"
                  new_node_array.push new_node.new(ip_from_mib, mac_from_mib, mask, status)
                }
              end

              new_node_array.each {|nnode|                
                if isValidIPv4(nnode.ip) and (nnode.mac != NILMAC) and isValidMac(nnode.mac)
                  if $host[nnode.ip]
                    #node already exists, check the mac
                    if $host[nnode.ip].mac != Node::NOARP_PROPERTY
                      if $host[nnode.ip].mac != nnode.mac
                        $event_win.add_event(EventWindow::AVAIL_EVENT_TYPE, "WARN", $host[nnode.ip], "Hardware MAC address collision, find #{nnode.mac}")
                      end
                    else
                      #mac is not set for this node at this point, so adding it
                      $host[nnode.ip].mac = nnode.mac
                      #ifOperStatus = The current operational state of the interface
                      #Values
                      #1 : up
                      #2 : down
                      #3 : testing
                      #4 : unknown
                      #5 : dormant
                      #6 : notPresent
                      #7 : lowerLayerDown
                      if nnode.status == 1
                        $host[nnode.ip].set_avail_severity(NORMAL)
                      elsif nnode.status == 2
                        $host[nnode.ip].set_avail_severity(CRITICAL)
                      end
                    end
                  else
                    if !$config.visible() and !in_exception_list(nnode.ip)
                      #node is not existing
                      if ($network_map_always == 1) and isValidIPv4($network_map_result) and !$network.has_key?($network_map_result)
                        $network_map_always = 0
                        $network_map_result = nil
                      end
                      if $network_map_always == 0
                        choose_network_map(nnode.ip)
                        while $network_map_result.nil?
                          sleep(2)
                        end
                      end
                      if !$network_map_result.nil? and !$network_map_result.empty?
                        if isValidIPv4($network_map_result)
                          map = $network_map_result
                          if $network.has_key?(map)
                            #mask depends on the interface where we found this node ip
                            if nnode.status == 1
                              addhostentry(nnode.ip, nnode.netmask, map, nnode.mac, NORMAL)
                            elsif nnode.status == 2
                              addhostentry(nnode.ip, nnode.netmask, map, nnode.mac, CRITICAL)
                            else
                              addhostentry(nnode.ip, nnode.netmask, map, nnode.mac)
                            end
                            sleep(2)
                          end
                        else
                          add_node_def_exception_list(nnode.ip)
                        end
                      end
                      if $network_map_always == 0
                        $network_map_result = nil
                      end
                    end
                  end
                end
              }
            end #new_node_array
          rescue SNMP::RequestTimeout
            $log.debug("tresolvesnmp: request timeout to #{ip} port: #{node.get_default_inherit_snmp_port().to_i} community: #{community_pub} snmp_version: #{get_snmp_version(node.get_default_inherit_snmp_version())}")
          rescue Errno::ENETUNREACH
            $log.error("tresolvesnmp: network is unreachable")
          rescue Exception => msg
            $log.error("tresolvesnmp: #{msg}\n#{msg.backtrace.join("\n")}")
          end
        end
        sleep($config.node_resolving_delay.to_i)
      end
    end
  }
end

#
# try to find a mac address for an IP
#
def tmacip ()
  Thread.start {
    while $config.mac_state
      sleep($config.mac_delay.to_i) #wait before all window are maps
      ip_table=$host.keys
      for ip in ip_table
        if !$config.mac_state
          break
        end
        if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
          if $host[ip] && $host[ip].mac == "(noarp)"
            begin
              timeout($config.mac_delay.to_i) {
                Thread.start {
                  res=mac(ip)
                  if res != ""
                    $host[ip].mac = res
                    $host[ip].change_label()
                  end
                }
                sleep(5)
              }
            rescue
              $log.info("difficulty to find MAC address for #{ip}")
            end
          else
            if $config.mac_lock #we verify mac address
              begin
                timeout($config.mac_delay.to_i) {
                  Thread.start {
                    #trying to get the mac addr using the arp table or snmp request
                    res=mac(ip)
                    if res != ""
                      if $host[ip] && $host[ip].mac != res && $host[ip].status != CRITICAL
                        $host[ip].set_avail_severity(MINOR)
                        $event_win.add_event(EventWindow::AVAIL_EVENT_TYPE, "WARN", $host[ip], "Hardware MAC address changed")
                      else
                        if $host[ip].status == MINOR
                          $host[ip].set_avail_severity(CRITICAL)
                        end
                      end
                    end
                  }
                  sleep(5)
                }
              rescue
              end
            end
          end
        end
      end
      sleep($config.mac_delay.to_i)
    end
  }
end

#
# try to find new host in another network
#
def tfindremotehost (map, mask)
  Thread.start {
    lhost=broadcast_remote_ping(map, mask)
    if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
      for ip in lhost
        add_host_entry_with_map(ip, mask, map)
      end
    end
  }
end

def t_find_remote_new_host ()
  Thread.start {
    while $config.active_find_node_state
      sleep($config.active_find_node_delay.to_i)
      $log.debug("in t_find_remote_new_host")
      $network.each_value {|node|
        if !$config.active_find_node_state
          break
        end
        if node.ip != ROOTMAPADDR
          lhost=broadcast_remote_ping(node.ip, node.netmask)
          #we secure the function call after
          if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
            for ip in lhost
              #puts "#{ip} dans t_find_remote_new_host"
              add_host_entry_with_map(ip, node.netmask, node.ip)
            end
          end
        end
      }
      sleep($config.active_find_node_delay.to_i)
    end
  }
end

#
# try to find new host in a given range IP addr
#
def tfindrangeremotehost (ip_begin, ip_end)
  Thread.start {
		$log.debug("in tfindrangeremotehost")
		lhost=range_remote_ping(ip_begin, ip_end)
		if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
		  for ip in lhost
		#puts "findrangeremotehost #{ip}"
	   	 add_host_entry_with_map(ip, 24, get_map())
		  end
		end
  }
end

#
# listen for new host in local network (broadcast)
#
def t_find_local_segment_pinging()
  Thread.start {
    while $config.active_find_node_state
      sleep($config.active_find_node_delay.to_i)
      if !defined?($in_confirm_exit_window) || ($in_confirm_exit_window == false)
        mask=local_mask()
        mask = DEFAULT_CLASS_C_NETMASK if !mask
        for ip in broadcast_ping
          #puts "t_find_local_segment_pinging #{ip} #{mask}"
          #test if network was removed during the time
          if ($network_map_always == 1) and isValidIPv4($network_map_result) and !$network.has_key?($network_map_result)
            $network_map_always = 0
            $network_map_result = nil
          end
          if $host and $host[ip].nil?
            if !$config.visible() and !in_exception_list(ip)
              if $network_map_always == 0
                choose_network_map(ip, IPCalc.get_network_addr(ip, mask))
                while $network_map_result.nil?
                  sleep(2)
                end
              end
              if !$network_map_result.nil? and !$network_map_result.empty?
                if isValidIPv4($network_map_result)
                  map = $network_map_result
                  if $network.has_key?(map)
                    addhostentry(ip, mask, map)
                    sleep(2)
                  end
                else
                  add_node_def_exception_list(ip)
                end
              end
              if $network_map_always == 0
                $network_map_result = nil
              end
            end
          end
        end
      end
      sleep($config.active_find_node_delay.to_i)
    end
  }
end

#
# threat which is sending SSDP discovery requests
#
def t_find_ssdp_discovery()
  if Process.euid != 0
    return
  end
  Thread.start {
    $log.debug("in t_find_ssdp_discovery")
    dest = "239.255.255.250"
    port = 1900      
    msearch =
    "M-SEARCH * HTTP/1.1\r\n" +
    "Host:#{dest}:#{port}\r\n" +
    "ST:upnp:rootdevice\r\n" +
    "Man:\"ssdp:discover\"\r\n" +
    "MX:3\r\n\r\n"
  
    udp_sock = UDPSocket.new
    while $config.passive_find_node_state
      begin
        udp_sock.bind("0.0.0.0", port)
      rescue Errno::EADDRINUSE
      rescue Errno::EINVAL
      rescue Exception => msg
        $log.error("in t_find_ssdp_discovery during udp binding: #{msg}")
      end
      begin
        udp_sock.send(msearch, 0, dest, port)
        res = nil
        1.upto(5) do
          res,addr,info = udp_sock.recvfrom(65535, 1.0)
          break if res and res =~ /^(Server|Location)/mi
          sleep(10)
          udp_sock.send msearch, 0, dest, port
        end
      rescue Exception => msg
        $log.error("in t_find_ssdp_discovery: #{msg}")
      end        
      sleep($config.passive_find_node_delay.to_i)
    end
  }
end

#
# analyze udp packet to port 1900
# trying to extract some upnp data
#
def ssdp_analyze(pkt)
  packet_info = [pkt.ip_saddr,  pkt.udp_dst]
  #we assume here dst port is set to default upnp port 1900
  #if pkt.udp_dst == 1900
  #puts "%s %s" % packet_info
  ssdp_body = pkt.udp_header.body
  #try to find the OS
  detected_os = "unknown"
  if ssdp_body.include?("M-SEARCH * HTTP/1.1") and ssdp_body.include?("ssdp:discover") and ssdp_body.include?("upnp:rootdevice")
    #puts "query"
    return [pkt.ip_saddr, detected_os]
  elsif ssdp_body.include?("HTTP/1.1 200 OK") and ssdp_body.include?("upnp:rootdevice")
    #puts "response"
    ssdp_body.each_line {|l|
      l.upcase!
      if l.include?("SERVER:")
        if l.include?("WINDOWS")
          detected_os = "windows"
        elsif l.include?("LINUX")
          detected_os = "linux"
        end
        return [pkt.ip_saddr, detected_os]
      end
    }
    return [pkt.ip_saddr, detected_os]
    #end
  end
  return nil
end

#
# passive scanning
# listen for new host in local network,
# sniffing for packets arp, lldp/cdp, upnp
#
def t_find_local_segment_sniffing()
  #run as root ?
  if Process.euid == 0
    begin
      require 'pcaprub'
      require 'packetfu'
    rescue LoadError => msg
      $log.error("Missing library #{msg}")
      return
    end

    iface = Pcap.lookupdev
    if iface
      Thread.start {
        cap =  PacketFu::Capture.new(:iface => iface, :start => false)
        begin
          cap.bpf(:filter => 'not ip')
        rescue
          $log.info("Can't set the bpf filter for sniff packets")
        end
        cap.start
        loop do
          cap.stream.each do |p|
            pkt = PacketFu::Packet.parse p
            if $config.passive_find_node_state and !$config.visible()
              if pkt.is_arp?
                #check if it's ethernet and arp reply
                if pkt.arp_hw == 1 and pkt.arp_opcode == 2
                  ip_mac_t = Array.new
                  ip_mac_t.push([pkt.arp_saddr_ip, pkt.arp_saddr_mac])
                  ip_mac_t.push([pkt.arp_daddr_ip, pkt.arp_daddr_mac])
                  ip_mac_t.each {|ip, mac|
                    $log.debug("t_find_local_segment_sniffing: ARP reply founds ip=#{ip} mac=#{mac}")
                    if isValidIPv4(ip) and !exist_host(ip) and !in_exception_list(ip)
                      if $network_map_always == 0
                        choose_network_map(ip)
                        while $network_map_result.nil?
                          sleep(2)
                        end
                      end
                      if !$network_map_result.nil? and !$network_map_result.empty?
                        if isValidIPv4($network_map_result)
                          map = $network_map_result
                          if $network.has_key?(map)
                            addhostentry(ip, 24, map)
                            sleep(2)
                            if $host[ip]
                              $host[ip].mac = mac
                            end
                          end
                        else
                          add_node_def_exception_list(ip)
                        end
                      end
                      if $network_map_always == 0
                        $network_map_result = nil
                      end
                    end
                  }
                end
              end
              #check for upnp ssdp packets
              if pkt.is_udp? and (pkt.udp_dst == 1900)
                result = ssdp_analyze(pkt)
                if !result.nil?
                  ip, os = result
                  $log.debug("t_find_local_segment_sniffing: SSDP founds ip=#{ip} os=#{os}")
                  if isValidIPv4(ip) and !exist_host(ip) and !in_exception_list(ip)                  
                    if $network_map_always == 0
                      choose_network_map(ip)
                      while $network_map_result.nil?
                        sleep(2)
                      end
                    end
                    if !$network_map_result.nil? and !$network_map_result.empty?
                      if isValidIPv4($network_map_result)
                        map = $network_map_result
                        if $network.has_key?(map)
                          addhostentry(ip, 24, map)
                          sleep(2)
                          if $host[ip] and (os != "unknown")
                            $host[ip].os = os
                          end
                        end
                      else
                        add_node_def_exception_list(ip)
                      end
                    end
                    if $network_map_always == 0
                      $network_map_result = nil
                    end                    
                  end
                end
              end
              begin
                if pkt.is_lldp?
                  $log.debug("t_find_local_segment_sniffing: LLDP founds ip=#{pkt.lldp_address} mac=#{pkt.lldp_saddr_mac}")
                  if (pkt.lldp_address_type_readable == "IPv4") and isValidIPv4(pkt.lldp_address) and !exist_host(pkt.lldp_address) and !in_exception_list(pkt.lldp_address)
                    if $network_map_always == 0
                      choose_network_map(pkt.lldp_address)
                      while $network_map_result.nil?
                        sleep(2)
                      end
                    end
                    if !$network_map_result.nil? and !$network_map_result.empty?
                      if isValidIPv4($network_map_result)
                        map = $network_map_result
                        if $network.has_key?(map)
                          addhostentry(pkt.lldp_address, 24, map)
                          sleep(2)
                          if $host[pkt.lldp_address]
                            $host[pkt.lldp_address].mac = pkt.lldp_saddr_mac
                            $host[pkt.lldp_address].name = pkt.lldp_system_name
                          end
                        end
                      else
                        add_node_def_exception_list(pkt.lldp_address)
                      end
                    end
                    if $network_map_always == 0
                      $network_map_result = nil
                    end
                  end
                end
              rescue NoMethodError
                #current gem version does not support lldp patch i sent
              end
            end
          end
        end
      }
    end
  else
    $log.error("t_find_local_segment_sniffing: Not enough privileges to sniff network packets, rerun as root")
    return
  end
end

#
# active scanning to find new nodes
#
def t_find_local_segment_scanning()

end

#
# scan a given ip, proto/port
# return 1 when the service is responding
# or 0
#
def scan_port(ip, proto, port)
  p1 = nil
  protocol = proto.upcase
  if protocol == "UDP"
    p1 = Net::Ping::UDP.new(ip, port)
  elsif protocol == "TCP"  
    p1 = Net::Ping::TCP.new(ip, port)
  end
  if !p1.nil? and p1.ping?
    return 1
  end
  return 0
end

#
# scan a given node
# trying to reach following services:
# ftp, ssh, http(s), dns, smtp, pop3,
# imap, nntp, ldap(s), kerberos, rdp
#
def portscan_node(n)

  tcp_service_to_check = [21, 22, 80, 25, 110, 143, 119, 389, 443, 636, 3389]
  udp_service_to_check = [53]
  
  udp_service_to_check.each {|port|
    p1 = Net::Ping::UDP.new(n.ip, port)
    if p1.ping?
      return 1
    end
  }
  
  tcp_service_to_check.each {|port|
    p1 = Net::Ping::TCP.new(n.ip, port)
    if p1.ping?
      return 1
    end
  }
  return 0  
end

#
# To know if we already know this ip
#
def contain(iplocal)
	i=0
	$host.each_key{|ip|	
		if ip == iplocal
			return i
		end
	i=i+1
	}
return -1
end

#
# Add new lign entry > pixmap & host-ip-button
#
def add_host_entry_with_map (ip, mask, map)
	#if host doesnt exist in array
	$log.debug("begin add_host_entry_with_map: #{ip}, #{mask}, #{map}")
	#test is done in add_network
	add_network(map, mask, get_map())

	if $host[ip] == nil
  		$event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", $host[ip], "Find new host")
		Gtk.thread_protect do
			add_host(ip,mask,map)
		end
	end
	$log.debug("end add_host_entry_with_map")
end

#
# Add new lign entry > pixmap & host-ip-button
#
def addhostentry(ip, mask, map=nil, mac=nil, avail=nil)
	#if host doesnt exist in array
	if $host[ip] == nil
		$event_win.add_event(EventWindow::CORE_EVENT_TYPE, "INFO", $host[ip], "Find new host")
		Gtk.thread_protect do
		  if map
			  add_host(ip, mask, map)
      else
			  add_host(ip, mask)
			end
      if !mac.nil?
        $host[ip].mac = mac
      end
      if !avail.nil?
        $host[ip].set_avail_severity(avail)
      end
		end
	end
end
