begin
  require "#{GNMSLIB}"+'/external/xmpp4r-simple.rb'
rescue LoadError
  $log.error("Xmpp4r is not installed, you should install the gem to have IM notification")
end

class XmppBot
  def initialize()
    #Jabber::debug = true
    if $config.im_daemon && ($config.im_login != "")
      @buff=MsgBuffer.new(1)
      $log.info("Starting XMPP bot")
      begin
        timeout(10) {@messenger = Jabber::Simple.new($config.im_login, $config.im_password)}
      rescue Timeout::Error
        $log.error("XMPP bot error: can't connect to #{$config.im_login}")
        return false
      rescue Exception=> msg
        $log.error("XMPP bot error: #{msg}")
        return false
      end
      @sender = Thread.start do
        while $config.im_daemon
          send_messages if @buff.full?
          sleep(2)
          Thread.pass
          @messenger.received_messages do |msg|
            $log.debug("Send from "+ msg.from.node+"@"+msg.from.domain + " \"#{msg.body}\"")
            case msg.body
            when /^help/i
              @messenger.deliver(msg.from, "status - display stats regarding host alived\nstatus ip - display the status of the given ip")
            when /^beer/i
              @messenger.deliver(msg.from, "Gimme a free beeeeeeeer")
            when /^status/i
              hup=0
              hdown=0
              begin
                $host.each_key {|ip|
                  if $host[ip] && ($host[ip].status == NORMAL)
                    hup=hup+1
                  else
                    hdown=hdown+1
                  end
                }
              rescue Exception => msg
                $log.error(msg)
              end
              @messenger.deliver(msg.from, "Active Host" + ($host.size<2?" ":"s ") + "#{hup}/#{$host.size}")
            when /^info\s+/i
              ipasked=msg.body.gsub(/info\s+/,"")
              if isValidIPv4(ipasked)
                if $host[ipasked]
                  @messenger.deliver(msg.from, "Ip node #{ipasked} status is #{$status[$status_value.index($host[ipasked].status)]}")
                elsif $network[ipasked]
                  @messenger.deliver(msg.from, "Network node #{ipasked} status is #{$status[$status_value.index($network[ipasked].status)]}")
                else
                  @messenger.deliver(msg.from, "Unkown ip address #{ipasked}")
                end
              else
                @messenger.deliver(msg.from, "#{ipasked} is not a valid ip address")
              end

            else
              @messenger.deliver(msg.from, "Sorry , I didn't understand that. Message me with 'help' for a list of commands")
            end
          end
        end
        $log.debug("end of XmppBot thread")
      end
    end
  end

  def add_in_queue(im_recipient, msg)
    $log.debug("xmpp add message in queue")
    if  $config.im_daemon
      @buff.put im_recipient+"|"+msg unless !@buff
    end
  end

  def stop()
    if defined?(@sender) && (@sender != nil)
      $log.info("Stopping XMPP bot")
      @messenger.disconnect unless !@messenger
      Thread.kill(@sender)
      $log.debug("end of XmppBot thread")
    end
  end

  private
  def send_messages()
    while @buff.has_more?
      im_msg=@buff.get
      if im_msg != nil
        begin
          $log.debug("in xmpp send_messages: #{im_msg}")
          pos=im_msg.index('|')
          @messenger.deliver(im_msg[0..pos-1],im_msg[pos+1..im_msg.size-1])
          sleep(2)
          Thread.pass if @buff.full?
        rescue Exception => msg
          #catch when stream is closed by close() method
          $log.error(msg)
        end
      end
    end
  end
end
