require "#{GNMSLIB}"+'/monitor/custom_plugin'
require 'resolv'

class DnsCheck < CustomPlugin
  #declare static methods
  def DnsCheck::description()
    return "Check if dns name resolved as the ip"
  end
  def DnsCheck::name()
    return "Check if dns name resolved as the ip"
  end
  def DnsCheck::default_severity()
    return "MAJOR"
  end
  def DnsCheck::parameter()
    return
  end
  
  def monitor()
    ip = get_node().ip
    service_name = "dns"
    dns_name = get_node().dns_name

    if (ip != "") and (dns_name != "") and (dns_name != Node::NONAME_PROPERTY)
      find = 0
      begin        
        dns = Resolv::DNS.new
        dns.getresources(dns_name, Resolv::DNS::Resource::IN::A).collect do |r|
          if r.address.to_s == ip
            find = 1
            break
          end
        end
      rescue Exception => msg
        raise(msg)
      end
      if find == 1
        set_state("NORMAL")
      else
        set_state("CRITICAL", "Dns name #{dns_name} is not resolving to IP address #{ip}")        
      end
    else
      raise("DnsCheck plugin can't be used as the IP or the DNS name is not set")
    end
  end
end
