require "#{GNMSLIB}"+'/monitor/custom_plugin'

begin
	require 'net/http'
	require 'uri'
rescue LoadError
	$log.fatal("HttpVirtualHostMonitor: you need to install http library for ruby")
end

class HttpVirtualHostMonitor < CustomPlugin
        #declare static methods
	def HttpVirtualHostMonitor::description()
	  return "Check HTTP Virtual Hosts using HTTP GET request"
	end
	def HttpVirtualHostMonitor::name()
	  return "Check HTTP Virtual Hosts"
	end
        def HttpVirtualHostMonitor::parameter()
          return "http://www.google.com"
        end
	def HttpVirtualHostMonitor::default_severity()
	  return "MAJOR"
	end
	
    def monitor()
	  host=get_node().ip
	  domain = HttpVirtualHostMonitor::parameter()

          begin
	     uri = URI("#{domain}")
	     res = Net::HTTP.get_response(uri)
	     case res
	     when Net::HTTPSuccess, Net::HTTPRedirection
	        set_state("NORMAL")
	     else
	        set_state("CRITICAL","Virtual Hosts is not responding, HTTP code #{res.code}")
             end
	  rescue
	     $log.error("Virtual Hosts plugin #{host}")
	     set_state("UNKNOWN")	
	  end
    end
end
