require "#{GNMSLIB}"+'/monitor/custom_plugin'

begin
	require 'mysql'
rescue LoadError
	$log.fatal("MysqlShowStatusMonitor: you need to install mysql library for ruby")
	$mysql_lib_error=false
	raise LoadError
end

class MysqlShowStatusMonitor < CustomPlugin
        #declare static methods
	def MysqlShowStatusMonitor::description()
	  return "Check slow thread or query using mysql connection"
	end
	def MysqlShowStatusMonitor::parameter()
	  return
	end	
	def MysqlShowStatusMonitor::name()
	  return "Check slow thread or query"
	end
        def MysqlShowStatusMonitor::default_severity()
	  return "MAJOR"
	end
		
	def monitor()
		host=get_node().ip
		database="mysql"
		max_value=5
		if ($mysql_lib_error!=false) && (get_node().get_account_id("mysql"))
  		   username, password = get_node().get_account_id("mysql")
		   begin
			# connect to the MySQL server
			dbh = Mysql.real_connect(host, username, password, database)
			# get server version string and display it
			#puts "Server version: " + dbh.get_server_info
			res = dbh.query("SHOW global status")
			val=0
			res.each do |row|
     			   #printf "%s, %s\n", row[0], row[1]
			   if (row[0] == "Slow_launch_threads") || (row[0] == "Slow_queries")
				   val+=row[1].to_i()
			   end
			end
			#puts "Number of rows returned: #{res.num_rows}"
			res.free
			if val>max_value
				set_state("CRITICAL","Mysql database slow status detected #{val} > #{max_value}")
			else
				set_state("NORMAL")
			end

		      rescue Mysql::Error => e
			#puts "Error code: #{e.errno}"
			#puts "Error message: #{e.error}"
			#puts "Error SQLSTATE: #{e.sqlstate}" if e.respond_to?("sqlstate")
			raise(e)
		      ensure
			# disconnect from server
			dbh.close if dbh
		      end
		else
			$log.error("mysql login/password not set for host #{host}")
			set_state("UNKNOWN")	
		end
	end
end
