require "#{GNMSLIB}"+'/monitor/custom_plugin'

begin
	require 'pg'
rescue LoadError
	$log.fatal("PgsqlPercentConnectionMonitor: you need to install ruby-pg library")
	$pg_lib_error=false
	raise LoadError
end

class PgsqlPercentConnectionMonitor < CustomPlugin
        #declare static methods
	def PgsqlPercentConnectionMonitor::description()
	  return "Check max connection (in %) using postgres connection"
	end
	def PgsqlPercentConnectionMonitor::parameter()
	  return
	end
	def PgsqlPercentConnectionMonitor::name()
	  return "Check max connection"
	end
	def PgsqlPercentConnectionMonitor::default_severity()
	  return "MAJOR"
	end
		
	def monitor()
		host=get_node().ip
		database="postgres"
		max_value=95		
		pgport=5432
		
		if ($pg_lib_error!= false) && (get_node().get_account_id("postgres"))
				
  		   username, password = get_node().get_account_id("postgres")
		   begin
			# connect to the PostgreSQL server
			dbh = PGconn.connect(host, pgport, "", "", database, username, password)

			val1=0
			res = dbh.exec("SELECT COUNT(*) FROM pg_stat_activity")
			if res.num_tuples > 0
				val1=res.getvalue(0, 0)
			end			
			res.clear

			val2=0
			res = dbh.exec("SHOW max_connections")
			if res.num_tuples > 0
				val2=res.getvalue(0, 0)
			end
			res.clear
			
			print "Max connection (%) used #{val1}/#{val2}\n"
			result=val1.to_f/val2.to_f
			
			if result > max_value.to_f
				set_state("CRITICAL","Postgresql database max connection reached #{result} > #{max_value.to_f}")
			else
				set_state("NORMAL")			
			end
			
		      rescue PGError => e
			#puts "Error code: #{e.errno}"
			#puts "Error message: #{e.error}"
			raise(e)
		      ensure
			# disconnect from server
			dbh.close if dbh
		      end
		else
			$log.error("Postgresql 'postgres' login/password not set for host #{host}")
			set_state("UNKNOWN")	
		end
	end
end
