require "#{GNMSLIB}"+'/monitor/custom_plugin'
#net telnet is a standard lib
require 'net/telnet'

class TelnetCpuLoadMonitor < CustomPlugin 
        #declare static methods
	def TelnetCpuLoadMonitor::description()
	  return "CPU load monitoring using Telnet connection to remotely read /proc/loadavg file"
	end
	def TelnetCpuLoadMonitor::name()
	  return "CPU load monitoring using Telnet"
	end
        def TelnetCpuLoadMonitor::parameter()
          return nil
        end	
	def TelnetCpuLoadMonitor::default_severity()
	  return "MAJOR"
	end
	
	def monitor()
		host=get_node().ip
		cmd="cat /proc/loadavg"
		max_cpuload=1.0
                service_name = "telnet"
		
		if get_node().get_account_id(service_name)
  	  		username, password = get_node().get_account_id(service_name)
                        define_port = 23
			serv = get_node().service_by_name(service_name)
			if serv
        		   if serv.protocol == "tcp"
			      define_port = serv.port
			   else
			      raise("Could not run TelnetCpuLoadMonitor using other protocol than TCP")
			   end
			end			
			begin
	 			hostsock = Net::Telnet::new("Host" => host,
				 "Port" => define_port,
                              	 "Timeout" => 10,
                              	 "Prompt" => /[$%#>] \z/n)
				hostsock.login(username, password)
				result=hostsock.cmd(cmd)
				hostsock.close

				#we remove the command string from the result
				resultt=result.gsub("#{cmd}\n",'')
				#we only extract cpu load on 15 minute period
				value=resultt.split(/\s/)[2]

				if isDouble(value)
					if value.to_f > max_cpuload
							set_state("CRITICAL", "CPU load exceeded > #{max_cpuload}")
					else
							set_state("NORMAL")
					end
				end
			rescue Timeout::Error
				$log.error("TelnetCpuLoadMonitor connection timeout to #{host}")
				raise("TelnetCpuLoadMonitor connection timeout")
			rescue Exception => msg
				raise("Telnet connection error")
			end
		else
			$log.error("Telnet login/password not set for host #{host}")
			set_state("UNKNOWN", "Telnet login/password not set")
		end
	end
end
